import CoreServices
from PyObjCTools.TestSupport import TestCase


class TestAIFF(TestCase):
    def assert_not_wrapped(self, name):
        self.assertTrue(
            not hasattr(CoreServices, name), f"{name!r} exposed in bindings"
        )

    def test_not_wrapped(self):
        self.assert_not_wrapped("paramErr")
        self.assert_not_wrapped("noHardwareErr")
        self.assert_not_wrapped("notEnoughHardwareErr")
        self.assert_not_wrapped("userCanceledErr")
        self.assert_not_wrapped("qErr")
        self.assert_not_wrapped("vTypErr")
        self.assert_not_wrapped("corErr")
        self.assert_not_wrapped("unimpErr")
        self.assert_not_wrapped("SlpTypeErr")
        self.assert_not_wrapped("seNoDB")
        self.assert_not_wrapped("controlErr")
        self.assert_not_wrapped("statusErr")
        self.assert_not_wrapped("readErr")
        self.assert_not_wrapped("writErr")
        self.assert_not_wrapped("badUnitErr")
        self.assert_not_wrapped("unitEmptyErr")
        self.assert_not_wrapped("openErr")
        self.assert_not_wrapped("closErr")
        self.assert_not_wrapped("dRemovErr")
        self.assert_not_wrapped("dInstErr")
        self.assert_not_wrapped("abortErr")
        self.assert_not_wrapped("iIOAbortErr")
        self.assert_not_wrapped("notOpenErr")
        self.assert_not_wrapped("unitTblFullErr")
        self.assert_not_wrapped("dceExtErr")
        self.assert_not_wrapped("slotNumErr")
        self.assert_not_wrapped("gcrOnMFMErr")
        self.assert_not_wrapped("dirFulErr")
        self.assert_not_wrapped("dskFulErr")
        self.assert_not_wrapped("nsvErr")
        self.assert_not_wrapped("ioErr")
        self.assert_not_wrapped("bdNamErr")
        self.assert_not_wrapped("fnOpnErr")
        self.assert_not_wrapped("eofErr")
        self.assert_not_wrapped("posErr")
        self.assert_not_wrapped("mFulErr")
        self.assert_not_wrapped("tmfoErr")
        self.assert_not_wrapped("fnfErr")
        self.assert_not_wrapped("wPrErr")
        self.assert_not_wrapped("fLckdErr")
        self.assert_not_wrapped("vLckdErr")
        self.assert_not_wrapped("fBsyErr")
        self.assert_not_wrapped("dupFNErr")
        self.assert_not_wrapped("opWrErr")
        self.assert_not_wrapped("rfNumErr")
        self.assert_not_wrapped("gfpErr")
        self.assert_not_wrapped("volOffLinErr")
        self.assert_not_wrapped("permErr")
        self.assert_not_wrapped("volOnLinErr")
        self.assert_not_wrapped("nsDrvErr")
        self.assert_not_wrapped("noMacDskErr")
        self.assert_not_wrapped("extFSErr")
        self.assert_not_wrapped("fsRnErr")
        self.assert_not_wrapped("badMDBErr")
        self.assert_not_wrapped("wrPermErr")
        self.assert_not_wrapped("dirNFErr")
        self.assert_not_wrapped("tmwdoErr")
        self.assert_not_wrapped("badMovErr")
        self.assert_not_wrapped("wrgVolTypErr")
        self.assert_not_wrapped("volGoneErr")
        self.assert_not_wrapped("fidNotFound")
        self.assert_not_wrapped("fidExists")
        self.assert_not_wrapped("notAFileErr")
        self.assert_not_wrapped("diffVolErr")
        self.assert_not_wrapped("catChangedErr")
        self.assert_not_wrapped("desktopDamagedErr")
        self.assert_not_wrapped("sameFileErr")
        self.assert_not_wrapped("badFidErr")
        self.assert_not_wrapped("notARemountErr")
        self.assert_not_wrapped("fileBoundsErr")
        self.assert_not_wrapped("fsDataTooBigErr")
        self.assert_not_wrapped("volVMBusyErr")
        self.assert_not_wrapped("badFCBErr")
        self.assert_not_wrapped("errFSUnknownCall")
        self.assert_not_wrapped("errFSBadFSRef")
        self.assert_not_wrapped("errFSBadForkName")
        self.assert_not_wrapped("errFSBadBuffer")
        self.assert_not_wrapped("errFSBadForkRef")
        self.assert_not_wrapped("errFSBadInfoBitmap")
        self.assert_not_wrapped("errFSMissingCatInfo")
        self.assert_not_wrapped("errFSNotAFolder")
        self.assert_not_wrapped("errFSForkNotFound")
        self.assert_not_wrapped("errFSNameTooLong")
        self.assert_not_wrapped("errFSMissingName")
        self.assert_not_wrapped("errFSBadPosMode")
        self.assert_not_wrapped("errFSBadAllocFlags")
        self.assert_not_wrapped("errFSNoMoreItems")
        self.assert_not_wrapped("errFSBadItemCount")
        self.assert_not_wrapped("errFSBadSearchParams")
        self.assert_not_wrapped("errFSRefsDifferent")
        self.assert_not_wrapped("errFSForkExists")
        self.assert_not_wrapped("errFSBadIteratorFlags")
        self.assert_not_wrapped("errFSIteratorNotFound")
        self.assert_not_wrapped("errFSIteratorNotSupported")
        self.assert_not_wrapped("errFSQuotaExceeded")
        self.assert_not_wrapped("errFSOperationNotSupported")
        self.assert_not_wrapped("errFSAttributeNotFound")
        self.assert_not_wrapped("errFSPropertyNotValid")
        self.assert_not_wrapped("errFSNotEnoughSpaceForOperation")
        self.assert_not_wrapped("envNotPresent")
        self.assert_not_wrapped("envBadVers")
        self.assert_not_wrapped("envVersTooBig")
        self.assert_not_wrapped("fontDecError")
        self.assert_not_wrapped("fontNotDeclared")
        self.assert_not_wrapped("fontSubErr")
        self.assert_not_wrapped("fontNotOutlineErr")
        self.assert_not_wrapped("firstDskErr")
        self.assert_not_wrapped("lastDskErr")
        self.assert_not_wrapped("noDriveErr")
        self.assert_not_wrapped("offLinErr")
        self.assert_not_wrapped("noNybErr")
        self.assert_not_wrapped("noAdrMkErr")
        self.assert_not_wrapped("dataVerErr")
        self.assert_not_wrapped("badCksmErr")
        self.assert_not_wrapped("badBtSlpErr")
        self.assert_not_wrapped("noDtaMkErr")
        self.assert_not_wrapped("badDCksum")
        self.assert_not_wrapped("badDBtSlp")
        self.assert_not_wrapped("wrUnderrun")
        self.assert_not_wrapped("cantStepErr")
        self.assert_not_wrapped("tk0BadErr")
        self.assert_not_wrapped("initIWMErr")
        self.assert_not_wrapped("twoSideErr")
        self.assert_not_wrapped("spdAdjErr")
        self.assert_not_wrapped("seekErr")
        self.assert_not_wrapped("sectNFErr")
        self.assert_not_wrapped("fmt1Err")
        self.assert_not_wrapped("fmt2Err")
        self.assert_not_wrapped("verErr")
        self.assert_not_wrapped("clkRdErr")
        self.assert_not_wrapped("clkWrErr")
        self.assert_not_wrapped("prWrErr")
        self.assert_not_wrapped("prInitErr")
        self.assert_not_wrapped("rcvrErr")
        self.assert_not_wrapped("breakRecd")
        self.assert_not_wrapped("noScrapErr")
        self.assert_not_wrapped("noTypeErr")
        self.assert_not_wrapped("eLenErr")
        self.assert_not_wrapped("eMultiErr")
        self.assert_not_wrapped("ddpSktErr")
        self.assert_not_wrapped("ddpLenErr")
        self.assert_not_wrapped("noBridgeErr")
        self.assert_not_wrapped("lapProtErr")
        self.assert_not_wrapped("excessCollsns")
        self.assert_not_wrapped("portNotPwr")
        self.assert_not_wrapped("portInUse")
        self.assert_not_wrapped("portNotCf")
        self.assert_not_wrapped("memROZWarn")
        self.assert_not_wrapped("memROZError")
        self.assert_not_wrapped("memROZErr")
        self.assert_not_wrapped("memFullErr")
        self.assert_not_wrapped("nilHandleErr")
        self.assert_not_wrapped("memWZErr")
        self.assert_not_wrapped("memPurErr")
        self.assert_not_wrapped("memAdrErr")
        self.assert_not_wrapped("memAZErr")
        self.assert_not_wrapped("memPCErr")
        self.assert_not_wrapped("memBCErr")
        self.assert_not_wrapped("memSCErr")
        self.assert_not_wrapped("memLockedErr")
        self.assert_not_wrapped("iMemFullErr")
        self.assert_not_wrapped("iIOAbort")
        self.assert_not_wrapped("resourceInMemory")
        self.assert_not_wrapped("writingPastEnd")
        self.assert_not_wrapped("inputOutOfBounds")
        self.assert_not_wrapped("resNotFound")
        self.assert_not_wrapped("resFNotFound")
        self.assert_not_wrapped("addResFailed")
        self.assert_not_wrapped("addRefFailed")
        self.assert_not_wrapped("rmvResFailed")
        self.assert_not_wrapped("rmvRefFailed")
        self.assert_not_wrapped("resAttrErr")
        self.assert_not_wrapped("mapReadErr")
        self.assert_not_wrapped("CantDecompress")
        self.assert_not_wrapped("badExtResource")
        self.assert_not_wrapped("noMemForPictPlaybackErr")
        self.assert_not_wrapped("rgnOverflowErr")
        self.assert_not_wrapped("rgnTooBigError")
        self.assert_not_wrapped("pixMapTooDeepErr")
        self.assert_not_wrapped("insufficientStackErr")
        self.assert_not_wrapped("nsStackErr")
        self.assert_not_wrapped("evtNotEnb")
        self.assert_not_wrapped("cMatchErr")
        self.assert_not_wrapped("cTempMemErr")
        self.assert_not_wrapped("cNoMemErr")
        self.assert_not_wrapped("cRangeErr")
        self.assert_not_wrapped("cProtectErr")
        self.assert_not_wrapped("cDevErr")
        self.assert_not_wrapped("cResErr")
        self.assert_not_wrapped("cDepthErr")
        self.assert_not_wrapped("rgnTooBigErr")
        self.assert_not_wrapped("updPixMemErr")
        self.assert_not_wrapped("pictInfoVersionErr")
        self.assert_not_wrapped("pictInfoIDErr")
        self.assert_not_wrapped("pictInfoVerbErr")
        self.assert_not_wrapped("cantLoadPickMethodErr")
        self.assert_not_wrapped("colorsRequestedErr")
        self.assert_not_wrapped("pictureDataErr")
        self.assert_not_wrapped("cmProfileError")
        self.assert_not_wrapped("cmMethodError")
        self.assert_not_wrapped("cmMethodNotFound")
        self.assert_not_wrapped("cmProfileNotFound")
        self.assert_not_wrapped("cmProfilesIdentical")
        self.assert_not_wrapped("cmCantConcatenateError")
        self.assert_not_wrapped("cmCantXYZ")
        self.assert_not_wrapped("cmCantDeleteProfile")
        self.assert_not_wrapped("cmUnsupportedDataType")
        self.assert_not_wrapped("cmNoCurrentProfile")
        self.assert_not_wrapped("noHardware")
        self.assert_not_wrapped("notEnoughHardware")
        self.assert_not_wrapped("queueFull")
        self.assert_not_wrapped("resProblem")
        self.assert_not_wrapped("badChannel")
        self.assert_not_wrapped("badFormat")
        self.assert_not_wrapped("notEnoughBufferSpace")
        self.assert_not_wrapped("badFileFormat")
        self.assert_not_wrapped("channelBusy")
        self.assert_not_wrapped("buffersTooSmall")
        self.assert_not_wrapped("channelNotBusy")
        self.assert_not_wrapped("noMoreRealTime")
        self.assert_not_wrapped("siVBRCompressionNotSupported")
        self.assert_not_wrapped("siNoSoundInHardware")
        self.assert_not_wrapped("siBadSoundInDevice")
        self.assert_not_wrapped("siNoBufferSpecified")
        self.assert_not_wrapped("siInvalidCompression")
        self.assert_not_wrapped("siHardDriveTooSlow")
        self.assert_not_wrapped("siInvalidSampleRate")
        self.assert_not_wrapped("siInvalidSampleSize")
        self.assert_not_wrapped("siDeviceBusyErr")
        self.assert_not_wrapped("siBadDeviceName")
        self.assert_not_wrapped("siBadRefNum")
        self.assert_not_wrapped("siInputDeviceErr")
        self.assert_not_wrapped("siUnknownInfoType")
        self.assert_not_wrapped("siUnknownQuality")
        self.assert_not_wrapped("noSynthFound")
        self.assert_not_wrapped("synthOpenFailed")
        self.assert_not_wrapped("synthNotReady")
        self.assert_not_wrapped("bufTooSmall")
        self.assert_not_wrapped("voiceNotFound")
        self.assert_not_wrapped("incompatibleVoice")
        self.assert_not_wrapped("badDictFormat")
        self.assert_not_wrapped("badInputText")
        self.assert_not_wrapped("midiNoClientErr")
        self.assert_not_wrapped("midiNoPortErr")
        self.assert_not_wrapped("midiTooManyPortsErr")
        self.assert_not_wrapped("midiTooManyConsErr")
        self.assert_not_wrapped("midiVConnectErr")
        self.assert_not_wrapped("midiVConnectMade")
        self.assert_not_wrapped("midiVConnectRmvd")
        self.assert_not_wrapped("midiNoConErr")
        self.assert_not_wrapped("midiWriteErr")
        self.assert_not_wrapped("midiNameLenErr")
        self.assert_not_wrapped("midiDupIDErr")
        self.assert_not_wrapped("midiInvalidCmdErr")
        self.assert_not_wrapped("nmTypErr")
        self.assert_not_wrapped("siInitSDTblErr")
        self.assert_not_wrapped("siInitVBLQsErr")
        self.assert_not_wrapped("siInitSPTblErr")
        self.assert_not_wrapped("sdmJTInitErr")
        self.assert_not_wrapped("sdmInitErr")
        self.assert_not_wrapped("sdmSRTInitErr")
        self.assert_not_wrapped("sdmPRAMInitErr")
        self.assert_not_wrapped("sdmPriInitErr")
        self.assert_not_wrapped("smSDMInitErr")
        self.assert_not_wrapped("smSRTInitErr")
        self.assert_not_wrapped("smPRAMInitErr")
        self.assert_not_wrapped("smPriInitErr")
        self.assert_not_wrapped("smEmptySlot")
        self.assert_not_wrapped("smCRCFail")
        self.assert_not_wrapped("smFormatErr")
        self.assert_not_wrapped("smRevisionErr")
        self.assert_not_wrapped("smNoDir")
        self.assert_not_wrapped("smDisabledSlot")
        self.assert_not_wrapped("smNosInfoArray")
        self.assert_not_wrapped("smResrvErr")
        self.assert_not_wrapped("smUnExBusErr")
        self.assert_not_wrapped("smBLFieldBad")
        self.assert_not_wrapped("smFHBlockRdErr")
        self.assert_not_wrapped("smFHBlkDispErr")
        self.assert_not_wrapped("smDisposePErr")
        self.assert_not_wrapped("smNoBoardSRsrc")
        self.assert_not_wrapped("smGetPRErr")
        self.assert_not_wrapped("smNoBoardId")
        self.assert_not_wrapped("smInitStatVErr")
        self.assert_not_wrapped("smInitTblVErr")
        self.assert_not_wrapped("smNoJmpTbl")
        self.assert_not_wrapped("smReservedSlot")
        self.assert_not_wrapped("smBadBoardId")
        self.assert_not_wrapped("smBusErrTO")
        self.assert_not_wrapped("svTempDisable")
        self.assert_not_wrapped("svDisabled")
        self.assert_not_wrapped("smBadRefId")
        self.assert_not_wrapped("smBadsList")
        self.assert_not_wrapped("smReservedErr")
        self.assert_not_wrapped("smCodeRevErr")
        self.assert_not_wrapped("smCPUErr")
        self.assert_not_wrapped("smsPointerNil")
        self.assert_not_wrapped("smNilsBlockErr")
        self.assert_not_wrapped("smSlotOOBErr")
        self.assert_not_wrapped("smSelOOBErr")
        self.assert_not_wrapped("smNewPErr")
        self.assert_not_wrapped("smBlkMoveErr")
        self.assert_not_wrapped("smCkStatusErr")
        self.assert_not_wrapped("smGetDrvrNamErr")
        self.assert_not_wrapped("smDisDrvrNamErr")
        self.assert_not_wrapped("smNoMoresRsrcs")
        self.assert_not_wrapped("smsGetDrvrErr")
        self.assert_not_wrapped("smBadsPtrErr")
        self.assert_not_wrapped("smByteLanesErr")
        self.assert_not_wrapped("smOffsetErr")
        self.assert_not_wrapped("smNoGoodOpens")
        self.assert_not_wrapped("smSRTOvrFlErr")
        self.assert_not_wrapped("smRecNotFnd")
        self.assert_not_wrapped("notBTree")
        self.assert_not_wrapped("btNoSpace")
        self.assert_not_wrapped("btDupRecErr")
        self.assert_not_wrapped("btRecNotFnd")
        self.assert_not_wrapped("btKeyLenErr")
        self.assert_not_wrapped("btKeyAttrErr")
        self.assert_not_wrapped("unknownInsertModeErr")
        self.assert_not_wrapped("recordDataTooBigErr")
        self.assert_not_wrapped("invalidIndexErr")
        self.assert_not_wrapped("fsmFFSNotFoundErr")
        self.assert_not_wrapped("fsmBusyFFSErr")
        self.assert_not_wrapped("fsmBadFFSNameErr")
        self.assert_not_wrapped("fsmBadFSDLenErr")
        self.assert_not_wrapped("fsmDuplicateFSIDErr")
        self.assert_not_wrapped("fsmBadFSDVersionErr")
        self.assert_not_wrapped("fsmNoAlternateStackErr")
        self.assert_not_wrapped("fsmUnknownFSMMessageErr")
        self.assert_not_wrapped("editionMgrInitErr")
        self.assert_not_wrapped("badSectionErr")
        self.assert_not_wrapped("notRegisteredSectionErr")
        self.assert_not_wrapped("badEditionFileErr")
        self.assert_not_wrapped("badSubPartErr")
        self.assert_not_wrapped("multiplePublisherWrn")
        self.assert_not_wrapped("containerNotFoundWrn")
        self.assert_not_wrapped("containerAlreadyOpenWrn")
        self.assert_not_wrapped("notThePublisherWrn")
        self.assert_not_wrapped("teScrapSizeErr")
        self.assert_not_wrapped("hwParamErr")
        self.assert_not_wrapped("driverHardwareGoneErr")
        self.assert_not_wrapped("procNotFound")
        self.assert_not_wrapped("memFragErr")
        self.assert_not_wrapped("appModeErr")
        self.assert_not_wrapped("protocolErr")
        self.assert_not_wrapped("hardwareConfigErr")
        self.assert_not_wrapped("appMemFullErr")
        self.assert_not_wrapped("appIsDaemon")
        self.assert_not_wrapped("bufferIsSmall")
        self.assert_not_wrapped("noOutstandingHLE")
        self.assert_not_wrapped("connectionInvalid")
        self.assert_not_wrapped("noUserInteractionAllowed")
        self.assert_not_wrapped("wrongApplicationPlatform")
        self.assert_not_wrapped("appVersionTooOld")
        self.assert_not_wrapped("notAppropriateForClassic")
        self.assert_not_wrapped("threadTooManyReqsErr")
        self.assert_not_wrapped("threadNotFoundErr")
        self.assert_not_wrapped("threadProtocolErr")
        self.assert_not_wrapped("threadBadAppContextErr")
        self.assert_not_wrapped("notEnoughMemoryErr")
        self.assert_not_wrapped("notHeldErr")
        self.assert_not_wrapped("cannotMakeContiguousErr")
        self.assert_not_wrapped("notLockedErr")
        self.assert_not_wrapped("interruptsMaskedErr")
        self.assert_not_wrapped("cannotDeferErr")
        self.assert_not_wrapped("noMMUErr")
        self.assert_not_wrapped("vmMorePhysicalThanVirtualErr")
        self.assert_not_wrapped("vmKernelMMUInitErr")
        self.assert_not_wrapped("vmOffErr")
        self.assert_not_wrapped("vmMemLckdErr")
        self.assert_not_wrapped("vmBadDriver")
        self.assert_not_wrapped("vmNoVectorErr")
        self.assert_not_wrapped("vmInvalidBackingFileIDErr")
        self.assert_not_wrapped("vmMappingPrivilegesErr")
        self.assert_not_wrapped("vmBusyBackingFileErr")
        self.assert_not_wrapped("vmNoMoreBackingFilesErr")
        self.assert_not_wrapped("vmInvalidFileViewIDErr")
        self.assert_not_wrapped("vmFileViewAccessErr")
        self.assert_not_wrapped("vmNoMoreFileViewsErr")
        self.assert_not_wrapped("vmAddressNotInFileViewErr")
        self.assert_not_wrapped("vmInvalidOwningProcessErr")
        self.assert_not_wrapped("rcDBNull")
        self.assert_not_wrapped("rcDBValue")
        self.assert_not_wrapped("rcDBError")
        self.assert_not_wrapped("rcDBBadType")
        self.assert_not_wrapped("rcDBBreak")
        self.assert_not_wrapped("rcDBExec")
        self.assert_not_wrapped("rcDBBadSessID")
        self.assert_not_wrapped("rcDBBadSessNum")
        self.assert_not_wrapped("rcDBBadDDEV")
        self.assert_not_wrapped("rcDBAsyncNotSupp")
        self.assert_not_wrapped("rcDBBadAsyncPB")
        self.assert_not_wrapped("rcDBNoHandler")
        self.assert_not_wrapped("rcDBWrongVersion")
        self.assert_not_wrapped("rcDBPackNotInited")
        self.assert_not_wrapped("hmHelpDisabled")
        self.assert_not_wrapped("hmBalloonAborted")
        self.assert_not_wrapped("hmSameAsLastBalloon")
        self.assert_not_wrapped("hmHelpManagerNotInited")
        self.assert_not_wrapped("hmSkippedBalloon")
        self.assert_not_wrapped("hmWrongVersion")
        self.assert_not_wrapped("hmUnknownHelpType")
        self.assert_not_wrapped("hmOperationUnsupported")
        self.assert_not_wrapped("hmNoBalloonUp")
        self.assert_not_wrapped("hmCloseViewActive")
        self.assert_not_wrapped("notInitErr")
        self.assert_not_wrapped("nameTypeErr")
        self.assert_not_wrapped("noPortErr")
        self.assert_not_wrapped("noGlobalsErr")
        self.assert_not_wrapped("localOnlyErr")
        self.assert_not_wrapped("destPortErr")
        self.assert_not_wrapped("sessTableErr")
        self.assert_not_wrapped("noSessionErr")
        self.assert_not_wrapped("badReqErr")
        self.assert_not_wrapped("portNameExistsErr")
        self.assert_not_wrapped("noUserNameErr")
        self.assert_not_wrapped("userRejectErr")
        self.assert_not_wrapped("noMachineNameErr")
        self.assert_not_wrapped("noToolboxNameErr")
        self.assert_not_wrapped("noResponseErr")
        self.assert_not_wrapped("portClosedErr")
        self.assert_not_wrapped("sessClosedErr")
        self.assert_not_wrapped("badPortNameErr")
        self.assert_not_wrapped("noDefaultUserErr")
        self.assert_not_wrapped("notLoggedInErr")
        self.assert_not_wrapped("noUserRefErr")
        self.assert_not_wrapped("networkErr")
        self.assert_not_wrapped("noInformErr")
        self.assert_not_wrapped("authFailErr")
        self.assert_not_wrapped("noUserRecErr")
        self.assert_not_wrapped("badServiceMethodErr")
        self.assert_not_wrapped("badLocNameErr")
        self.assert_not_wrapped("guestNotAllowedErr")
        self.assert_not_wrapped("kFMIterationCompleted")
        self.assert_not_wrapped("kFMInvalidFontFamilyErr")
        self.assert_not_wrapped("kFMInvalidFontErr")
        self.assert_not_wrapped("kFMIterationScopeModifiedErr")
        self.assert_not_wrapped("kFMFontTableAccessErr")
        self.assert_not_wrapped("kFMFontContainerAccessErr")
        self.assert_not_wrapped("noMaskFoundErr")
        self.assert_not_wrapped("nbpBuffOvr")
        self.assert_not_wrapped("nbpNoConfirm")
        self.assert_not_wrapped("nbpConfDiff")
        self.assert_not_wrapped("nbpDuplicate")
        self.assert_not_wrapped("nbpNotFound")
        self.assert_not_wrapped("nbpNISErr")
        self.assert_not_wrapped("aspBadVersNum")
        self.assert_not_wrapped("aspBufTooSmall")
        self.assert_not_wrapped("aspNoMoreSess")
        self.assert_not_wrapped("aspNoServers")
        self.assert_not_wrapped("aspParamErr")
        self.assert_not_wrapped("aspServerBusy")
        self.assert_not_wrapped("aspSessClosed")
        self.assert_not_wrapped("aspSizeErr")
        self.assert_not_wrapped("aspTooMany")
        self.assert_not_wrapped("aspNoAck")
        self.assert_not_wrapped("reqFailed")
        self.assert_not_wrapped("tooManyReqs")
        self.assert_not_wrapped("tooManySkts")
        self.assert_not_wrapped("badATPSkt")
        self.assert_not_wrapped("badBuffNum")
        self.assert_not_wrapped("noRelErr")
        self.assert_not_wrapped("cbNotFound")
        self.assert_not_wrapped("noSendResp")
        self.assert_not_wrapped("noDataArea")
        self.assert_not_wrapped("reqAborted")
        self.assert_not_wrapped("errRefNum")
        self.assert_not_wrapped("errAborted")
        self.assert_not_wrapped("errState")
        self.assert_not_wrapped("errOpening")
        self.assert_not_wrapped("errAttention")
        self.assert_not_wrapped("errFwdReset")
        self.assert_not_wrapped("errDSPQueueSize")
        self.assert_not_wrapped("errOpenDenied")
        self.assert_not_wrapped("errAECoercionFail")
        self.assert_not_wrapped("errAEDescNotFound")
        self.assert_not_wrapped("errAECorruptData")
        self.assert_not_wrapped("errAEWrongDataType")
        self.assert_not_wrapped("errAENotAEDesc")
        self.assert_not_wrapped("errAEBadListItem")
        self.assert_not_wrapped("errAENewerVersion")
        self.assert_not_wrapped("errAENotAppleEvent")
        self.assert_not_wrapped("errAEEventNotHandled")
        self.assert_not_wrapped("errAEReplyNotValid")
        self.assert_not_wrapped("errAEUnknownSendMode")
        self.assert_not_wrapped("errAEWaitCanceled")
        self.assert_not_wrapped("errAETimeout")
        self.assert_not_wrapped("errAENoUserInteraction")
        self.assert_not_wrapped("errAENotASpecialFunction")
        self.assert_not_wrapped("errAEParamMissed")
        self.assert_not_wrapped("errAEUnknownAddressType")
        self.assert_not_wrapped("errAEHandlerNotFound")
        self.assert_not_wrapped("errAEReplyNotArrived")
        self.assert_not_wrapped("errAEIllegalIndex")
        self.assert_not_wrapped("errAEImpossibleRange")
        self.assert_not_wrapped("errAEWrongNumberArgs")
        self.assert_not_wrapped("errAEAccessorNotFound")
        self.assert_not_wrapped("errAENoSuchLogical")
        self.assert_not_wrapped("errAEBadTestKey")
        self.assert_not_wrapped("errAENotAnObjSpec")
        self.assert_not_wrapped("errAENoSuchObject")
        self.assert_not_wrapped("errAENegativeCount")
        self.assert_not_wrapped("errAEEmptyListContainer")
        self.assert_not_wrapped("errAEUnknownObjectType")
        self.assert_not_wrapped("errAERecordingIsAlreadyOn")
        self.assert_not_wrapped("errAEReceiveTerminate")
        self.assert_not_wrapped("errAEReceiveEscapeCurrent")
        self.assert_not_wrapped("errAEEventFiltered")
        self.assert_not_wrapped("errAEDuplicateHandler")
        self.assert_not_wrapped("errAEStreamBadNesting")
        self.assert_not_wrapped("errAEStreamAlreadyConverted")
        self.assert_not_wrapped("errAEDescIsNull")
        self.assert_not_wrapped("errAEBuildSyntaxError")
        self.assert_not_wrapped("errAEBufferTooSmall")
        self.assert_not_wrapped("errOSASystemError")
        self.assert_not_wrapped("errOSAInvalidID")
        self.assert_not_wrapped("errOSABadStorageType")
        self.assert_not_wrapped("errOSAScriptError")
        self.assert_not_wrapped("errOSABadSelector")
        self.assert_not_wrapped("errOSASourceNotAvailable")
        self.assert_not_wrapped("errOSANoSuchDialect")
        self.assert_not_wrapped("errOSADataFormatObsolete")
        self.assert_not_wrapped("errOSADataFormatTooNew")
        self.assert_not_wrapped("errOSACorruptData")
        self.assert_not_wrapped("errOSARecordingIsAlreadyOn")
        self.assert_not_wrapped("errOSAComponentMismatch")
        self.assert_not_wrapped("errOSACantOpenComponent")
        self.assert_not_wrapped("errOSACantStorePointers")
        self.assert_not_wrapped("errOffsetInvalid")
        self.assert_not_wrapped("errOffsetIsOutsideOfView")
        self.assert_not_wrapped("errTopOfDocument")
        self.assert_not_wrapped("errTopOfBody")
        self.assert_not_wrapped("errEndOfDocument")
        self.assert_not_wrapped("errEndOfBody")
        self.assert_not_wrapped("badDragRefErr")
        self.assert_not_wrapped("badDragItemErr")
        self.assert_not_wrapped("badDragFlavorErr")
        self.assert_not_wrapped("duplicateFlavorErr")
        self.assert_not_wrapped("cantGetFlavorErr")
        self.assert_not_wrapped("duplicateHandlerErr")
        self.assert_not_wrapped("handlerNotFoundErr")
        self.assert_not_wrapped("dragNotAcceptedErr")
        self.assert_not_wrapped("unsupportedForPlatformErr")
        self.assert_not_wrapped("noSuitableDisplaysErr")
        self.assert_not_wrapped("badImageRgnErr")
        self.assert_not_wrapped("badImageErr")
        self.assert_not_wrapped("nonDragOriginatorErr")
        self.assert_not_wrapped("couldNotResolveDataRef")
        self.assert_not_wrapped("badImageDescription")
        self.assert_not_wrapped("badPublicMovieAtom")
        self.assert_not_wrapped("cantFindHandler")
        self.assert_not_wrapped("cantOpenHandler")
        self.assert_not_wrapped("badComponentType")
        self.assert_not_wrapped("noMediaHandler")
        self.assert_not_wrapped("noDataHandler")
        self.assert_not_wrapped("invalidMedia")
        self.assert_not_wrapped("invalidTrack")
        self.assert_not_wrapped("invalidMovie")
        self.assert_not_wrapped("invalidSampleTable")
        self.assert_not_wrapped("invalidDataRef")
        self.assert_not_wrapped("invalidHandler")
        self.assert_not_wrapped("invalidDuration")
        self.assert_not_wrapped("invalidTime")
        self.assert_not_wrapped("cantPutPublicMovieAtom")
        self.assert_not_wrapped("badEditList")
        self.assert_not_wrapped("mediaTypesDontMatch")
        self.assert_not_wrapped("progressProcAborted")
        self.assert_not_wrapped("movieToolboxUninitialized")
        self.assert_not_wrapped("noRecordOfApp")
        self.assert_not_wrapped("wfFileNotFound")
        self.assert_not_wrapped("cantCreateSingleForkFile")
        self.assert_not_wrapped("invalidEditState")
        self.assert_not_wrapped("nonMatchingEditState")
        self.assert_not_wrapped("staleEditState")
        self.assert_not_wrapped("userDataItemNotFound")
        self.assert_not_wrapped("maxSizeToGrowTooSmall")
        self.assert_not_wrapped("badTrackIndex")
        self.assert_not_wrapped("trackIDNotFound")
        self.assert_not_wrapped("trackNotInMovie")
        self.assert_not_wrapped("timeNotInTrack")
        self.assert_not_wrapped("timeNotInMedia")
        self.assert_not_wrapped("badEditIndex")
        self.assert_not_wrapped("internalQuickTimeError")
        self.assert_not_wrapped("cantEnableTrack")
        self.assert_not_wrapped("invalidRect")
        self.assert_not_wrapped("invalidSampleNum")
        self.assert_not_wrapped("invalidChunkNum")
        self.assert_not_wrapped("invalidSampleDescIndex")
        self.assert_not_wrapped("invalidChunkCache")
        self.assert_not_wrapped("invalidSampleDescription")
        self.assert_not_wrapped("dataNotOpenForRead")
        self.assert_not_wrapped("dataNotOpenForWrite")
        self.assert_not_wrapped("dataAlreadyOpenForWrite")
        self.assert_not_wrapped("dataAlreadyClosed")
        self.assert_not_wrapped("endOfDataReached")
        self.assert_not_wrapped("dataNoDataRef")
        self.assert_not_wrapped("noMovieFound")
        self.assert_not_wrapped("invalidDataRefContainer")
        self.assert_not_wrapped("badDataRefIndex")
        self.assert_not_wrapped("noDefaultDataRef")
        self.assert_not_wrapped("couldNotUseAnExistingSample")
        self.assert_not_wrapped("featureUnsupported")
        self.assert_not_wrapped("noVideoTrackInMovieErr")
        self.assert_not_wrapped("noSoundTrackInMovieErr")
        self.assert_not_wrapped("soundSupportNotAvailableErr")
        self.assert_not_wrapped("unsupportedAuxiliaryImportData")
        self.assert_not_wrapped("auxiliaryExportDataUnavailable")
        self.assert_not_wrapped("samplesAlreadyInMediaErr")
        self.assert_not_wrapped("noSourceTreeFoundErr")
        self.assert_not_wrapped("sourceNotFoundErr")
        self.assert_not_wrapped("movieTextNotFoundErr")
        self.assert_not_wrapped("missingRequiredParameterErr")
        self.assert_not_wrapped("invalidSpriteWorldPropertyErr")
        self.assert_not_wrapped("invalidSpritePropertyErr")
        self.assert_not_wrapped("gWorldsNotSameDepthAndSizeErr")
        self.assert_not_wrapped("invalidSpriteIndexErr")
        self.assert_not_wrapped("invalidImageIndexErr")
        self.assert_not_wrapped("invalidSpriteIDErr")
        self.assert_not_wrapped("internalComponentErr")
        self.assert_not_wrapped("notImplementedMusicOSErr")
        self.assert_not_wrapped("cantSendToSynthesizerOSErr")
        self.assert_not_wrapped("cantReceiveFromSynthesizerOSErr")
        self.assert_not_wrapped("illegalVoiceAllocationOSErr")
        self.assert_not_wrapped("illegalPartOSErr")
        self.assert_not_wrapped("illegalChannelOSErr")
        self.assert_not_wrapped("illegalKnobOSErr")
        self.assert_not_wrapped("illegalKnobValueOSErr")
        self.assert_not_wrapped("illegalInstrumentOSErr")
        self.assert_not_wrapped("illegalControllerOSErr")
        self.assert_not_wrapped("midiManagerAbsentOSErr")
        self.assert_not_wrapped("synthesizerNotRespondingOSErr")
        self.assert_not_wrapped("synthesizerOSErr")
        self.assert_not_wrapped("illegalNoteChannelOSErr")
        self.assert_not_wrapped("noteChannelNotAllocatedOSErr")
        self.assert_not_wrapped("tunePlayerFullOSErr")
        self.assert_not_wrapped("tuneParseOSErr")
        self.assert_not_wrapped("noExportProcAvailableErr")
        self.assert_not_wrapped("videoOutputInUseErr")
        self.assert_not_wrapped("componentDllLoadErr")
        self.assert_not_wrapped("componentDllEntryNotFoundErr")
        self.assert_not_wrapped("qtmlDllLoadErr")
        self.assert_not_wrapped("qtmlDllEntryNotFoundErr")
        self.assert_not_wrapped("qtmlUninitialized")
        self.assert_not_wrapped("unsupportedOSErr")
        self.assert_not_wrapped("unsupportedProcessorErr")
        self.assert_not_wrapped("componentNotThreadSafeErr")
        self.assert_not_wrapped("cannotFindAtomErr")
        self.assert_not_wrapped("notLeafAtomErr")
        self.assert_not_wrapped("atomsNotOfSameTypeErr")
        self.assert_not_wrapped("atomIndexInvalidErr")
        self.assert_not_wrapped("duplicateAtomTypeAndIDErr")
        self.assert_not_wrapped("invalidAtomErr")
        self.assert_not_wrapped("invalidAtomContainerErr")
        self.assert_not_wrapped("invalidAtomTypeErr")
        self.assert_not_wrapped("cannotBeLeafAtomErr")
        self.assert_not_wrapped("pathTooLongErr")
        self.assert_not_wrapped("emptyPathErr")
        self.assert_not_wrapped("noPathMappingErr")
        self.assert_not_wrapped("pathNotVerifiedErr")
        self.assert_not_wrapped("unknownFormatErr")
        self.assert_not_wrapped("wackBadFileErr")
        self.assert_not_wrapped("wackForkNotFoundErr")
        self.assert_not_wrapped("wackBadMetaDataErr")
        self.assert_not_wrapped("qfcbNotFoundErr")
        self.assert_not_wrapped("qfcbNotCreatedErr")
        self.assert_not_wrapped("AAPNotCreatedErr")
        self.assert_not_wrapped("AAPNotFoundErr")
        self.assert_not_wrapped("ASDBadHeaderErr")
        self.assert_not_wrapped("ASDBadForkErr")
        self.assert_not_wrapped("ASDEntryNotFoundErr")
        self.assert_not_wrapped("fileOffsetTooBigErr")
        self.assert_not_wrapped("notAllowedToSaveMovieErr")
        self.assert_not_wrapped("qtNetworkAlreadyAllocatedErr")
        self.assert_not_wrapped("urlDataHHTTPProtocolErr")
        self.assert_not_wrapped("urlDataHHTTPNoNetDriverErr")
        self.assert_not_wrapped("urlDataHHTTPURLErr")
        self.assert_not_wrapped("urlDataHHTTPRedirectErr")
        self.assert_not_wrapped("urlDataHFTPProtocolErr")
        self.assert_not_wrapped("urlDataHFTPShutdownErr")
        self.assert_not_wrapped("urlDataHFTPBadUserErr")
        self.assert_not_wrapped("urlDataHFTPBadPasswordErr")
        self.assert_not_wrapped("urlDataHFTPServerErr")
        self.assert_not_wrapped("urlDataHFTPDataConnectionErr")
        self.assert_not_wrapped("urlDataHFTPNoDirectoryErr")
        self.assert_not_wrapped("urlDataHFTPQuotaErr")
        self.assert_not_wrapped("urlDataHFTPPermissionsErr")
        self.assert_not_wrapped("urlDataHFTPFilenameErr")
        self.assert_not_wrapped("urlDataHFTPNoNetDriverErr")
        self.assert_not_wrapped("urlDataHFTPBadNameListErr")
        self.assert_not_wrapped("urlDataHFTPNeedPasswordErr")
        self.assert_not_wrapped("urlDataHFTPNoPasswordErr")
        self.assert_not_wrapped("urlDataHFTPServerDisconnectedErr")
        self.assert_not_wrapped("urlDataHFTPURLErr")
        self.assert_not_wrapped("notEnoughDataErr")
        self.assert_not_wrapped("qtActionNotHandledErr")
        self.assert_not_wrapped("qtXMLParseErr")
        self.assert_not_wrapped("qtXMLApplicationErr")
        self.assert_not_wrapped("digiUnimpErr")
        self.assert_not_wrapped("qtParamErr")
        self.assert_not_wrapped("matrixErr")
        self.assert_not_wrapped("notExactMatrixErr")
        self.assert_not_wrapped("noMoreKeyColorsErr")
        self.assert_not_wrapped("notExactSizeErr")
        self.assert_not_wrapped("badDepthErr")
        self.assert_not_wrapped("noDMAErr")
        self.assert_not_wrapped("badCallOrderErr")
        self.assert_not_wrapped("kernelIncompleteErr")
        self.assert_not_wrapped("kernelCanceledErr")
        self.assert_not_wrapped("kernelOptionsErr")
        self.assert_not_wrapped("kernelPrivilegeErr")
        self.assert_not_wrapped("kernelUnsupportedErr")
        self.assert_not_wrapped("kernelObjectExistsErr")
        self.assert_not_wrapped("kernelWritePermissionErr")
        self.assert_not_wrapped("kernelReadPermissionErr")
        self.assert_not_wrapped("kernelExecutePermissionErr")
        self.assert_not_wrapped("kernelDeletePermissionErr")
        self.assert_not_wrapped("kernelExecutionLevelErr")
        self.assert_not_wrapped("kernelAttributeErr")
        self.assert_not_wrapped("kernelAsyncSendLimitErr")
        self.assert_not_wrapped("kernelAsyncReceiveLimitErr")
        self.assert_not_wrapped("kernelTimeoutErr")
        self.assert_not_wrapped("kernelInUseErr")
        self.assert_not_wrapped("kernelTerminatedErr")
        self.assert_not_wrapped("kernelExceptionErr")
        self.assert_not_wrapped("kernelIDErr")
        self.assert_not_wrapped("kernelAlreadyFreeErr")
        self.assert_not_wrapped("kernelReturnValueErr")
        self.assert_not_wrapped("kernelUnrecoverableErr")
        self.assert_not_wrapped("tsmComponentNoErr")
        self.assert_not_wrapped("tsmUnsupScriptLanguageErr")
        self.assert_not_wrapped("tsmInputMethodNotFoundErr")
        self.assert_not_wrapped("tsmNotAnAppErr")
        self.assert_not_wrapped("tsmAlreadyRegisteredErr")
        self.assert_not_wrapped("tsmNeverRegisteredErr")
        self.assert_not_wrapped("tsmInvalidDocIDErr")
        self.assert_not_wrapped("tsmTSMDocBusyErr")
        self.assert_not_wrapped("tsmDocNotActiveErr")
        self.assert_not_wrapped("tsmNoOpenTSErr")
        self.assert_not_wrapped("tsmCantOpenComponentErr")
        self.assert_not_wrapped("tsmTextServiceNotFoundErr")
        self.assert_not_wrapped("tsmDocumentOpenErr")
        self.assert_not_wrapped("tsmUseInputWindowErr")
        self.assert_not_wrapped("tsmTSHasNoMenuErr")
        self.assert_not_wrapped("tsmTSNotOpenErr")
        self.assert_not_wrapped("tsmComponentAlreadyOpenErr")
        self.assert_not_wrapped("tsmInputMethodIsOldErr")
        self.assert_not_wrapped("tsmScriptHasNoIMErr")
        self.assert_not_wrapped("tsmUnsupportedTypeErr")
        self.assert_not_wrapped("tsmUnknownErr")
        self.assert_not_wrapped("tsmInvalidContext")
        self.assert_not_wrapped("tsmNoHandler")
        self.assert_not_wrapped("tsmNoMoreTokens")
        self.assert_not_wrapped("tsmNoStem")
        self.assert_not_wrapped("tsmDefaultIsNotInputMethodErr")
        self.assert_not_wrapped("tsmDocPropertyNotFoundErr")
        self.assert_not_wrapped("tsmDocPropertyBufferTooSmallErr")
        self.assert_not_wrapped("tsmCantChangeForcedClassStateErr")
        self.assert_not_wrapped("tsmComponentPropertyUnsupportedErr")
        self.assert_not_wrapped("tsmComponentPropertyNotFoundErr")
        self.assert_not_wrapped("tsmInputModeChangeFailedErr")
        self.assert_not_wrapped("mmInternalError")
        self.assert_not_wrapped("nrLockedErr")
        self.assert_not_wrapped("nrNotEnoughMemoryErr")
        self.assert_not_wrapped("nrInvalidNodeErr")
        self.assert_not_wrapped("nrNotFoundErr")
        self.assert_not_wrapped("nrNotCreatedErr")
        self.assert_not_wrapped("nrNameErr")
        self.assert_not_wrapped("nrNotSlotDeviceErr")
        self.assert_not_wrapped("nrDataTruncatedErr")
        self.assert_not_wrapped("nrPowerErr")
        self.assert_not_wrapped("nrPowerSwitchAbortErr")
        self.assert_not_wrapped("nrTypeMismatchErr")
        self.assert_not_wrapped("nrNotModifiedErr")
        self.assert_not_wrapped("nrOverrunErr")
        self.assert_not_wrapped("nrResultCodeBase")
        self.assert_not_wrapped("nrPathNotFound")
        self.assert_not_wrapped("nrPathBufferTooSmall")
        self.assert_not_wrapped("nrInvalidEntryIterationOp")
        self.assert_not_wrapped("nrPropertyAlreadyExists")
        self.assert_not_wrapped("nrIterationDone")
        self.assert_not_wrapped("nrExitedIteratorScope")
        self.assert_not_wrapped("nrTransactionAborted")
        self.assert_not_wrapped("nrCallNotSupported")
        self.assert_not_wrapped("invalidIconRefErr")
        self.assert_not_wrapped("noSuchIconErr")
        self.assert_not_wrapped("noIconDataAvailableErr")
        self.assert_not_wrapped("errOSACantCoerce")
        self.assert_not_wrapped("errOSACantAccess")
        self.assert_not_wrapped("errOSACantAssign")
        self.assert_not_wrapped("errOSAGeneralError")
        self.assert_not_wrapped("errOSADivideByZero")
        self.assert_not_wrapped("errOSANumericOverflow")
        self.assert_not_wrapped("errOSACantLaunch")
        self.assert_not_wrapped("errOSAAppNotHighLevelEventAware")
        self.assert_not_wrapped("errOSACorruptTerminology")
        self.assert_not_wrapped("errOSAStackOverflow")
        self.assert_not_wrapped("errOSAInternalTableOverflow")
        self.assert_not_wrapped("errOSADataBlockTooLarge")
        self.assert_not_wrapped("errOSACantGetTerminology")
        self.assert_not_wrapped("errOSACantCreate")
        self.assert_not_wrapped("errOSATypeError")
        self.assert_not_wrapped("OSAMessageNotUnderstood")
        self.assert_not_wrapped("OSAUndefinedHandler")
        self.assert_not_wrapped("OSAIllegalAccess")
        self.assert_not_wrapped("OSAIllegalIndex")
        self.assert_not_wrapped("OSAIllegalRange")
        self.assert_not_wrapped("OSAIllegalAssign")
        self.assert_not_wrapped("OSASyntaxError")
        self.assert_not_wrapped("OSASyntaxTypeError")
        self.assert_not_wrapped("OSATokenTooLong")
        self.assert_not_wrapped("OSAMissingParameter")
        self.assert_not_wrapped("OSAParameterMismatch")
        self.assert_not_wrapped("OSADuplicateParameter")
        self.assert_not_wrapped("OSADuplicateProperty")
        self.assert_not_wrapped("OSADuplicateHandler")
        self.assert_not_wrapped("OSAUndefinedVariable")
        self.assert_not_wrapped("OSAInconsistentDeclarations")
        self.assert_not_wrapped("OSAControlFlowError")
        self.assert_not_wrapped("errASCantConsiderAndIgnore")
        self.assert_not_wrapped("errASCantCompareMoreThan32k")
        self.assert_not_wrapped("errASTerminologyNestingTooDeep")
        self.assert_not_wrapped("errASIllegalFormalParameter")
        self.assert_not_wrapped("errASParameterNotForEvent")
        self.assert_not_wrapped("errASNoResultReturned")
        self.assert_not_wrapped("errASInconsistentNames")
        self.assert_not_wrapped("cfragFirstErrCode")
        self.assert_not_wrapped("cfragContextIDErr")
        self.assert_not_wrapped("cfragConnectionIDErr")
        self.assert_not_wrapped("cfragNoSymbolErr")
        self.assert_not_wrapped("cfragNoSectionErr")
        self.assert_not_wrapped("cfragNoLibraryErr")
        self.assert_not_wrapped("cfragDupRegistrationErr")
        self.assert_not_wrapped("cfragFragmentFormatErr")
        self.assert_not_wrapped("cfragUnresolvedErr")
        self.assert_not_wrapped("cfragNoPositionErr")
        self.assert_not_wrapped("cfragNoPrivateMemErr")
        self.assert_not_wrapped("cfragNoClientMemErr")
        self.assert_not_wrapped("cfragNoIDsErr")
        self.assert_not_wrapped("cfragInitOrderErr")
        self.assert_not_wrapped("cfragImportTooOldErr")
        self.assert_not_wrapped("cfragImportTooNewErr")
        self.assert_not_wrapped("cfragInitLoopErr")
        self.assert_not_wrapped("cfragInitAtBootErr")
        self.assert_not_wrapped("cfragLibConnErr")
        self.assert_not_wrapped("cfragCFMStartupErr")
        self.assert_not_wrapped("cfragCFMInternalErr")
        self.assert_not_wrapped("cfragFragmentCorruptErr")
        self.assert_not_wrapped("cfragInitFunctionErr")
        self.assert_not_wrapped("cfragNoApplicationErr")
        self.assert_not_wrapped("cfragArchitectureErr")
        self.assert_not_wrapped("cfragFragmentUsageErr")
        self.assert_not_wrapped("cfragFileSizeErr")
        self.assert_not_wrapped("cfragNotClosureErr")
        self.assert_not_wrapped("cfragNoRegistrationErr")
        self.assert_not_wrapped("cfragContainerIDErr")
        self.assert_not_wrapped("cfragClosureIDErr")
        self.assert_not_wrapped("cfragAbortClosureErr")
        self.assert_not_wrapped("cfragOutputLengthErr")
        self.assert_not_wrapped("cfragMapFileErr")
        self.assert_not_wrapped("cfragExecFileRefErr")
        self.assert_not_wrapped("cfragStdFolderErr")
        self.assert_not_wrapped("cfragRsrcForkErr")
        self.assert_not_wrapped("cfragCFragRsrcErr")
        self.assert_not_wrapped("cfragLastErrCode")
        self.assert_not_wrapped("cfragFirstReservedCode")
        self.assert_not_wrapped("cfragReservedCode_3")
        self.assert_not_wrapped("cfragReservedCode_2")
        self.assert_not_wrapped("cfragReservedCode_1")
        self.assert_not_wrapped("fragContextNotFound")
        self.assert_not_wrapped("fragConnectionIDNotFound")
        self.assert_not_wrapped("fragSymbolNotFound")
        self.assert_not_wrapped("fragSectionNotFound")
        self.assert_not_wrapped("fragLibNotFound")
        self.assert_not_wrapped("fragDupRegLibName")
        self.assert_not_wrapped("fragFormatUnknown")
        self.assert_not_wrapped("fragHadUnresolveds")
        self.assert_not_wrapped("fragNoMem")
        self.assert_not_wrapped("fragNoAddrSpace")
        self.assert_not_wrapped("fragNoContextIDs")
        self.assert_not_wrapped("fragObjectInitSeqErr")
        self.assert_not_wrapped("fragImportTooOld")
        self.assert_not_wrapped("fragImportTooNew")
        self.assert_not_wrapped("fragInitLoop")
        self.assert_not_wrapped("fragInitRtnUsageErr")
        self.assert_not_wrapped("fragLibConnErr")
        self.assert_not_wrapped("fragMgrInitErr")
        self.assert_not_wrapped("fragConstErr")
        self.assert_not_wrapped("fragCorruptErr")
        self.assert_not_wrapped("fragUserInitProcErr")
        self.assert_not_wrapped("fragAppNotFound")
        self.assert_not_wrapped("fragArchError")
        self.assert_not_wrapped("fragInvalidFragmentUsage")
        self.assert_not_wrapped("fragLastErrCode")
        self.assert_not_wrapped("invalidComponentID")
        self.assert_not_wrapped("validInstancesExist")
        self.assert_not_wrapped("componentNotCaptured")
        self.assert_not_wrapped("componentDontRegister")
        self.assert_not_wrapped("unresolvedComponentDLLErr")
        self.assert_not_wrapped("retryComponentRegistrationErr")
        self.assert_not_wrapped("invalidTranslationPathErr")
        self.assert_not_wrapped("couldNotParseSourceFileErr")
        self.assert_not_wrapped("noTranslationPathErr")
        self.assert_not_wrapped("badTranslationSpecErr")
        self.assert_not_wrapped("noPrefAppErr")
        self.assert_not_wrapped("buf2SmallErr")
        self.assert_not_wrapped("noMPPErr")
        self.assert_not_wrapped("ckSumErr")
        self.assert_not_wrapped("extractErr")
        self.assert_not_wrapped("readQErr")
        self.assert_not_wrapped("atpLenErr")
        self.assert_not_wrapped("atpBadRsp")
        self.assert_not_wrapped("recNotFnd")
        self.assert_not_wrapped("sktClosedErr")
        self.assert_not_wrapped("kOTNoError")
        self.assert_not_wrapped("kOTOutOfMemoryErr")
        self.assert_not_wrapped("kOTNotFoundErr")
        self.assert_not_wrapped("kOTDuplicateFoundErr")
        self.assert_not_wrapped("kOTBadAddressErr")
        self.assert_not_wrapped("kOTBadOptionErr")
        self.assert_not_wrapped("kOTAccessErr")
        self.assert_not_wrapped("kOTBadReferenceErr")
        self.assert_not_wrapped("kOTNoAddressErr")
        self.assert_not_wrapped("kOTOutStateErr")
        self.assert_not_wrapped("kOTBadSequenceErr")
        self.assert_not_wrapped("kOTSysErrorErr")
        self.assert_not_wrapped("kOTLookErr")
        self.assert_not_wrapped("kOTBadDataErr")
        self.assert_not_wrapped("kOTBufferOverflowErr")
        self.assert_not_wrapped("kOTFlowErr")
        self.assert_not_wrapped("kOTNoDataErr")
        self.assert_not_wrapped("kOTNoDisconnectErr")
        self.assert_not_wrapped("kOTNoUDErrErr")
        self.assert_not_wrapped("kOTBadFlagErr")
        self.assert_not_wrapped("kOTNoReleaseErr")
        self.assert_not_wrapped("kOTNotSupportedErr")
        self.assert_not_wrapped("kOTStateChangeErr")
        self.assert_not_wrapped("kOTNoStructureTypeErr")
        self.assert_not_wrapped("kOTBadNameErr")
        self.assert_not_wrapped("kOTBadQLenErr")
        self.assert_not_wrapped("kOTAddressBusyErr")
        self.assert_not_wrapped("kOTIndOutErr")
        self.assert_not_wrapped("kOTProviderMismatchErr")
        self.assert_not_wrapped("kOTResQLenErr")
        self.assert_not_wrapped("kOTResAddressErr")
        self.assert_not_wrapped("kOTQFullErr")
        self.assert_not_wrapped("kOTProtocolErr")
        self.assert_not_wrapped("kOTBadSyncErr")
        self.assert_not_wrapped("kOTCanceledErr")
        self.assert_not_wrapped("kEPERMErr")
        self.assert_not_wrapped("kENOENTErr")
        self.assert_not_wrapped("kENORSRCErr")
        self.assert_not_wrapped("kEINTRErr")
        self.assert_not_wrapped("kEIOErr")
        self.assert_not_wrapped("kENXIOErr")
        self.assert_not_wrapped("kEBADFErr")
        self.assert_not_wrapped("kEAGAINErr")
        self.assert_not_wrapped("kENOMEMErr")
        self.assert_not_wrapped("kEACCESErr")
        self.assert_not_wrapped("kEFAULTErr")
        self.assert_not_wrapped("kEBUSYErr")
        self.assert_not_wrapped("kEEXISTErr")
        self.assert_not_wrapped("kENODEVErr")
        self.assert_not_wrapped("kEINVALErr")
        self.assert_not_wrapped("kENOTTYErr")
        self.assert_not_wrapped("kEPIPEErr")
        self.assert_not_wrapped("kERANGEErr")
        self.assert_not_wrapped("kEWOULDBLOCKErr")
        self.assert_not_wrapped("kEDEADLKErr")
        self.assert_not_wrapped("kEALREADYErr")
        self.assert_not_wrapped("kENOTSOCKErr")
        self.assert_not_wrapped("kEDESTADDRREQErr")
        self.assert_not_wrapped("kEMSGSIZEErr")
        self.assert_not_wrapped("kEPROTOTYPEErr")
        self.assert_not_wrapped("kENOPROTOOPTErr")
        self.assert_not_wrapped("kEPROTONOSUPPORTErr")
        self.assert_not_wrapped("kESOCKTNOSUPPORTErr")
        self.assert_not_wrapped("kEOPNOTSUPPErr")
        self.assert_not_wrapped("kEADDRINUSEErr")
        self.assert_not_wrapped("kEADDRNOTAVAILErr")
        self.assert_not_wrapped("kENETDOWNErr")
        self.assert_not_wrapped("kENETUNREACHErr")
        self.assert_not_wrapped("kENETRESETErr")
        self.assert_not_wrapped("kECONNABORTEDErr")
        self.assert_not_wrapped("kECONNRESETErr")
        self.assert_not_wrapped("kENOBUFSErr")
        self.assert_not_wrapped("kEISCONNErr")
        self.assert_not_wrapped("kENOTCONNErr")
        self.assert_not_wrapped("kESHUTDOWNErr")
        self.assert_not_wrapped("kETOOMANYREFSErr")
        self.assert_not_wrapped("kETIMEDOUTErr")
        self.assert_not_wrapped("kECONNREFUSEDErr")
        self.assert_not_wrapped("kEHOSTDOWNErr")
        self.assert_not_wrapped("kEHOSTUNREACHErr")
        self.assert_not_wrapped("kEPROTOErr")
        self.assert_not_wrapped("kETIMEErr")
        self.assert_not_wrapped("kENOSRErr")
        self.assert_not_wrapped("kEBADMSGErr")
        self.assert_not_wrapped("kECANCELErr")
        self.assert_not_wrapped("kENOSTRErr")
        self.assert_not_wrapped("kENODATAErr")
        self.assert_not_wrapped("kEINPROGRESSErr")
        self.assert_not_wrapped("kESRCHErr")
        self.assert_not_wrapped("kENOMSGErr")
        self.assert_not_wrapped("kOTClientNotInittedErr")
        self.assert_not_wrapped("kOTPortHasDiedErr")
        self.assert_not_wrapped("kOTPortWasEjectedErr")
        self.assert_not_wrapped("kOTBadConfigurationErr")
        self.assert_not_wrapped("kOTConfigurationChangedErr")
        self.assert_not_wrapped("kOTUserRequestedErr")
        self.assert_not_wrapped("kOTPortLostConnection")
        self.assert_not_wrapped("kQDNoPalette")
        self.assert_not_wrapped("kQDNoColorHWCursorSupport")
        self.assert_not_wrapped("kQDCursorAlreadyRegistered")
        self.assert_not_wrapped("kQDCursorNotRegistered")
        self.assert_not_wrapped("kQDCorruptPICTDataErr")
        self.assert_not_wrapped("firstPickerError")
        self.assert_not_wrapped("invalidPickerType")
        self.assert_not_wrapped("requiredFlagsDontMatch")
        self.assert_not_wrapped("pickerResourceError")
        self.assert_not_wrapped("cantLoadPicker")
        self.assert_not_wrapped("cantCreatePickerWindow")
        self.assert_not_wrapped("cantLoadPackage")
        self.assert_not_wrapped("pickerCantLive")
        self.assert_not_wrapped("colorSyncNotInstalled")
        self.assert_not_wrapped("badProfileError")
        self.assert_not_wrapped("noHelpForItem")
        self.assert_not_wrapped("kNSL68kContextNotSupported")
        self.assert_not_wrapped("kNSLSchedulerError")
        self.assert_not_wrapped("kNSLBadURLSyntax")
        self.assert_not_wrapped("kNSLNoCarbonLib")
        self.assert_not_wrapped("kNSLUILibraryNotAvailable")
        self.assert_not_wrapped("kNSLNotImplementedYet")
        self.assert_not_wrapped("kNSLErrNullPtrError")
        self.assert_not_wrapped("kNSLSomePluginsFailedToLoad")
        self.assert_not_wrapped("kNSLNullNeighborhoodPtr")
        self.assert_not_wrapped("kNSLNoPluginsForSearch")
        self.assert_not_wrapped("kNSLSearchAlreadyInProgress")
        self.assert_not_wrapped("kNSLNoPluginsFound")
        self.assert_not_wrapped("kNSLPluginLoadFailed")
        self.assert_not_wrapped("kNSLBadProtocolTypeErr")
        self.assert_not_wrapped("kNSLNullListPtr")
        self.assert_not_wrapped("kNSLBadClientInfoPtr")
        self.assert_not_wrapped("kNSLCannotContinueLookup")
        self.assert_not_wrapped("kNSLBufferTooSmallForData")
        self.assert_not_wrapped("kNSLNoContextAvailable")
        self.assert_not_wrapped("kNSLRequestBufferAlreadyInList")
        self.assert_not_wrapped("kNSLInvalidPluginSpec")
        self.assert_not_wrapped("kNSLNoSupportForService")
        self.assert_not_wrapped("kNSLBadNetConnection")
        self.assert_not_wrapped("kNSLBadDataTypeErr")
        self.assert_not_wrapped("kNSLBadServiceTypeErr")
        self.assert_not_wrapped("kNSLBadReferenceErr")
        self.assert_not_wrapped("kNSLNoElementsInList")
        self.assert_not_wrapped("kNSLInsufficientOTVer")
        self.assert_not_wrapped("kNSLInsufficientSysVer")
        self.assert_not_wrapped("kNSLNotInitialized")
        self.assert_not_wrapped("kNSLInitializationFailed")
        self.assert_not_wrapped("kDTPHoldJobErr")
        self.assert_not_wrapped("kDTPStopQueueErr")
        self.assert_not_wrapped("kDTPTryAgainErr")
        self.assert_not_wrapped("kDTPAbortJobErr")
        self.assert_not_wrapped("cmElementTagNotFound")
        self.assert_not_wrapped("cmIndexRangeErr")
        self.assert_not_wrapped("cmCantDeleteElement")
        self.assert_not_wrapped("cmFatalProfileErr")
        self.assert_not_wrapped("cmInvalidProfile")
        self.assert_not_wrapped("cmInvalidProfileLocation")
        self.assert_not_wrapped("cmCantCopyModifiedV1Profile")
        self.assert_not_wrapped("cmInvalidSearch")
        self.assert_not_wrapped("cmSearchError")
        self.assert_not_wrapped("cmErrIncompatibleProfile")
        self.assert_not_wrapped("cmInvalidColorSpace")
        self.assert_not_wrapped("cmInvalidSrcMap")
        self.assert_not_wrapped("cmInvalidDstMap")
        self.assert_not_wrapped("cmNoGDevicesError")
        self.assert_not_wrapped("cmInvalidProfileComment")
        self.assert_not_wrapped("cmRangeOverFlow")
        self.assert_not_wrapped("cmNamedColorNotFound")
        self.assert_not_wrapped("cmCantGamutCheckError")
        self.assert_not_wrapped("badFolderDescErr")
        self.assert_not_wrapped("duplicateFolderDescErr")
        self.assert_not_wrapped("noMoreFolderDescErr")
        self.assert_not_wrapped("invalidFolderTypeErr")
        self.assert_not_wrapped("duplicateRoutingErr")
        self.assert_not_wrapped("routingNotFoundErr")
        self.assert_not_wrapped("badRoutingSizeErr")
        self.assert_not_wrapped("coreFoundationUnknownErr")
        self.assert_not_wrapped("errCoreEndianDataTooShortForFormat")
        self.assert_not_wrapped("errCoreEndianDataTooLongForFormat")
        self.assert_not_wrapped("errCoreEndianDataDoesNotMatchFormat")
        self.assert_not_wrapped("internalScrapErr")
        self.assert_not_wrapped("duplicateScrapFlavorErr")
        self.assert_not_wrapped("badScrapRefErr")
        self.assert_not_wrapped("processStateIncorrectErr")
        self.assert_not_wrapped("scrapPromiseNotKeptErr")
        self.assert_not_wrapped("noScrapPromiseKeeperErr")
        self.assert_not_wrapped("nilScrapFlavorDataErr")
        self.assert_not_wrapped("scrapFlavorFlagsMismatchErr")
        self.assert_not_wrapped("scrapFlavorSizeMismatchErr")
        self.assert_not_wrapped("illegalScrapFlavorFlagsErr")
        self.assert_not_wrapped("illegalScrapFlavorTypeErr")
        self.assert_not_wrapped("illegalScrapFlavorSizeErr")
        self.assert_not_wrapped("scrapFlavorNotFoundErr")
        self.assert_not_wrapped("needClearScrapErr")
        self.assert_not_wrapped("afpAccessDenied")
        self.assert_not_wrapped("afpAuthContinue")
        self.assert_not_wrapped("afpBadUAM")
        self.assert_not_wrapped("afpBadVersNum")
        self.assert_not_wrapped("afpBitmapErr")
        self.assert_not_wrapped("afpCantMove")
        self.assert_not_wrapped("afpDenyConflict")
        self.assert_not_wrapped("afpDirNotEmpty")
        self.assert_not_wrapped("afpDiskFull")
        self.assert_not_wrapped("afpEofError")
        self.assert_not_wrapped("afpFileBusy")
        self.assert_not_wrapped("afpFlatVol")
        self.assert_not_wrapped("afpItemNotFound")
        self.assert_not_wrapped("afpLockErr")
        self.assert_not_wrapped("afpMiscErr")
        self.assert_not_wrapped("afpNoMoreLocks")
        self.assert_not_wrapped("afpNoServer")
        self.assert_not_wrapped("afpObjectExists")
        self.assert_not_wrapped("afpObjectNotFound")
        self.assert_not_wrapped("afpParmErr")
        self.assert_not_wrapped("afpRangeNotLocked")
        self.assert_not_wrapped("afpRangeOverlap")
        self.assert_not_wrapped("afpSessClosed")
        self.assert_not_wrapped("afpUserNotAuth")
        self.assert_not_wrapped("afpCallNotSupported")
        self.assert_not_wrapped("afpObjectTypeErr")
        self.assert_not_wrapped("afpTooManyFilesOpen")
        self.assert_not_wrapped("afpServerGoingDown")
        self.assert_not_wrapped("afpCantRename")
        self.assert_not_wrapped("afpDirNotFound")
        self.assert_not_wrapped("afpIconTypeError")
        self.assert_not_wrapped("afpVolLocked")
        self.assert_not_wrapped("afpObjectLocked")
        self.assert_not_wrapped("afpContainsSharedErr")
        self.assert_not_wrapped("afpIDNotFound")
        self.assert_not_wrapped("afpIDExists")
        self.assert_not_wrapped("afpDiffVolErr")
        self.assert_not_wrapped("afpCatalogChanged")
        self.assert_not_wrapped("afpSameObjectErr")
        self.assert_not_wrapped("afpBadIDErr")
        self.assert_not_wrapped("afpPwdSameErr")
        self.assert_not_wrapped("afpPwdTooShortErr")
        self.assert_not_wrapped("afpPwdExpiredErr")
        self.assert_not_wrapped("afpInsideSharedErr")
        self.assert_not_wrapped("afpInsideTrashErr")
        self.assert_not_wrapped("afpPwdNeedsChangeErr")
        self.assert_not_wrapped("afpPwdPolicyErr")
        self.assert_not_wrapped("afpAlreadyLoggedInErr")
        self.assert_not_wrapped("afpCallNotAllowed")
        self.assert_not_wrapped("afpBadDirIDType")
        self.assert_not_wrapped("afpCantMountMoreSrvre")
        self.assert_not_wrapped("afpAlreadyMounted")
        self.assert_not_wrapped("afpSameNodeErr")
        self.assert_not_wrapped("numberFormattingNotANumberErr")
        self.assert_not_wrapped("numberFormattingOverflowInDestinationErr")
        self.assert_not_wrapped("numberFormattingBadNumberFormattingObjectErr")
        self.assert_not_wrapped("numberFormattingSpuriousCharErr")
        self.assert_not_wrapped("numberFormattingLiteralMissingErr")
        self.assert_not_wrapped("numberFormattingDelimiterMissingErr")
        self.assert_not_wrapped("numberFormattingEmptyFormatErr")
        self.assert_not_wrapped("numberFormattingBadFormatErr")
        self.assert_not_wrapped("numberFormattingBadOptionsErr")
        self.assert_not_wrapped("numberFormattingBadTokenErr")
        self.assert_not_wrapped("numberFormattingUnOrderedCurrencyRangeErr")
        self.assert_not_wrapped("numberFormattingBadCurrencyPositionErr")
        self.assert_not_wrapped("numberFormattingNotADigitErr")
        self.assert_not_wrapped("numberFormattingUnOrdredCurrencyRangeErr")
        self.assert_not_wrapped("numberFortmattingNotADigitErr")
        self.assert_not_wrapped("textParserBadParamErr")
        self.assert_not_wrapped("textParserObjectNotFoundErr")
        self.assert_not_wrapped("textParserBadTokenValueErr")
        self.assert_not_wrapped("textParserBadParserObjectErr")
        self.assert_not_wrapped("textParserParamErr")
        self.assert_not_wrapped("textParserNoMoreTextErr")
        self.assert_not_wrapped("textParserBadTextLanguageErr")
        self.assert_not_wrapped("textParserBadTextEncodingErr")
        self.assert_not_wrapped("textParserNoSuchTokenFoundErr")
        self.assert_not_wrapped("textParserNoMoreTokensErr")
        self.assert_not_wrapped("errUnknownAttributeTag")
        self.assert_not_wrapped("errMarginWilllNotFit")
        self.assert_not_wrapped("errNotInImagingMode")
        self.assert_not_wrapped("errAlreadyInImagingMode")
        self.assert_not_wrapped("errEngineNotFound")
        self.assert_not_wrapped("errIteratorReachedEnd")
        self.assert_not_wrapped("errInvalidRange")
        self.assert_not_wrapped("errOffsetNotOnElementBounday")
        self.assert_not_wrapped("errNoHiliteText")
        self.assert_not_wrapped("errEmptyScrap")
        self.assert_not_wrapped("errReadOnlyText")
        self.assert_not_wrapped("errUnknownElement")
        self.assert_not_wrapped("errNonContiuousAttribute")
        self.assert_not_wrapped("errCannotUndo")
        self.assert_not_wrapped("hrHTMLRenderingLibNotInstalledErr")
        self.assert_not_wrapped("hrMiscellaneousExceptionErr")
        self.assert_not_wrapped("hrUnableToResizeHandleErr")
        self.assert_not_wrapped("hrURLNotHandledErr")
        self.assert_not_wrapped("errIANoErr")
        self.assert_not_wrapped("errIAUnknownErr")
        self.assert_not_wrapped("errIAAllocationErr")
        self.assert_not_wrapped("errIAParamErr")
        self.assert_not_wrapped("errIANoMoreItems")
        self.assert_not_wrapped("errIABufferTooSmall")
        self.assert_not_wrapped("errIACanceled")
        self.assert_not_wrapped("errIAInvalidDocument")
        self.assert_not_wrapped("errIATextExtractionErr")
        self.assert_not_wrapped("errIAEndOfTextRun")
        self.assert_not_wrapped("qtsBadSelectorErr")
        self.assert_not_wrapped("qtsBadStateErr")
        self.assert_not_wrapped("qtsBadDataErr")
        self.assert_not_wrapped("qtsUnsupportedDataTypeErr")
        self.assert_not_wrapped("qtsUnsupportedRateErr")
        self.assert_not_wrapped("qtsUnsupportedFeatureErr")
        self.assert_not_wrapped("qtsTooMuchDataErr")
        self.assert_not_wrapped("qtsUnknownValueErr")
        self.assert_not_wrapped("qtsTimeoutErr")
        self.assert_not_wrapped("qtsConnectionFailedErr")
        self.assert_not_wrapped("qtsAddressBusyErr")
        self.assert_not_wrapped("gestaltUnknownErr")
        self.assert_not_wrapped("gestaltUndefSelectorErr")
        self.assert_not_wrapped("gestaltDupSelectorErr")
        self.assert_not_wrapped("gestaltLocationErr")
        self.assert_not_wrapped("menuPropertyInvalidErr")
        self.assert_not_wrapped("menuPropertyInvalid")
        self.assert_not_wrapped("menuPropertyNotFoundErr")
        self.assert_not_wrapped("menuNotFoundErr")
        self.assert_not_wrapped("menuUsesSystemDefErr")
        self.assert_not_wrapped("menuItemNotFoundErr")
        self.assert_not_wrapped("menuInvalidErr")
        self.assert_not_wrapped("errInvalidWindowPtr")
        self.assert_not_wrapped("errInvalidWindowRef")
        self.assert_not_wrapped("errUnsupportedWindowAttributesForClass")
        self.assert_not_wrapped("errWindowDoesNotHaveProxy")
        self.assert_not_wrapped("errInvalidWindowProperty")
        self.assert_not_wrapped("errWindowPropertyNotFound")
        self.assert_not_wrapped("errUnrecognizedWindowClass")
        self.assert_not_wrapped("errCorruptWindowDescription")
        self.assert_not_wrapped("errUserWantsToDragWindow")
        self.assert_not_wrapped("errWindowsAlreadyInitialized")
        self.assert_not_wrapped("errFloatingWindowsNotInitialized")
        self.assert_not_wrapped("errWindowNotFound")
        self.assert_not_wrapped("errWindowDoesNotFitOnscreen")
        self.assert_not_wrapped("windowAttributeImmutableErr")
        self.assert_not_wrapped("windowAttributesConflictErr")
        self.assert_not_wrapped("windowManagerInternalErr")
        self.assert_not_wrapped("windowWrongStateErr")
        self.assert_not_wrapped("windowGroupInvalidErr")
        self.assert_not_wrapped("windowAppModalStateAlreadyExistsErr")
        self.assert_not_wrapped("windowNoAppModalStateErr")
        self.assert_not_wrapped("errWindowDoesntSupportFocus")
        self.assert_not_wrapped("errWindowRegionCodeInvalid")
        self.assert_not_wrapped("dialogNoTimeoutErr")
        self.assert_not_wrapped("kNavWrongDialogStateErr")
        self.assert_not_wrapped("kNavWrongDialogClassErr")
        self.assert_not_wrapped("kNavInvalidSystemConfigErr")
        self.assert_not_wrapped("kNavCustomControlMessageFailedErr")
        self.assert_not_wrapped("kNavInvalidCustomControlMessageErr")
        self.assert_not_wrapped("kNavMissingKindStringErr")
        self.assert_not_wrapped("collectionItemLockedErr")
        self.assert_not_wrapped("collectionItemNotFoundErr")
        self.assert_not_wrapped("collectionIndexRangeErr")
        self.assert_not_wrapped("collectionVersionErr")
        self.assert_not_wrapped("kQTSSUnknownErr")
        self.assert_not_wrapped("kDMGenErr")
        self.assert_not_wrapped("kDMMirroringOnAlready")
        self.assert_not_wrapped("kDMWrongNumberOfDisplays")
        self.assert_not_wrapped("kDMMirroringBlocked")
        self.assert_not_wrapped("kDMCantBlock")
        self.assert_not_wrapped("kDMMirroringNotOn")
        self.assert_not_wrapped("kSysSWTooOld")
        self.assert_not_wrapped("kDMSWNotInitializedErr")
        self.assert_not_wrapped("kDMDriverNotDisplayMgrAwareErr")
        self.assert_not_wrapped("kDMDisplayNotFoundErr")
        self.assert_not_wrapped("kDMNotFoundErr")
        self.assert_not_wrapped("kDMDisplayAlreadyInstalledErr")
        self.assert_not_wrapped("kDMMainDisplayCannotMoveErr")
        self.assert_not_wrapped("kDMNoDeviceTableclothErr")
        self.assert_not_wrapped("kDMFoundErr")
        self.assert_not_wrapped("laTooSmallBufferErr")
        self.assert_not_wrapped("laEnvironmentBusyErr")
        self.assert_not_wrapped("laEnvironmentNotFoundErr")
        self.assert_not_wrapped("laEnvironmentExistErr")
        self.assert_not_wrapped("laInvalidPathErr")
        self.assert_not_wrapped("laNoMoreMorphemeErr")
        self.assert_not_wrapped("laFailAnalysisErr")
        self.assert_not_wrapped("laTextOverFlowErr")
        self.assert_not_wrapped("laDictionaryNotOpenedErr")
        self.assert_not_wrapped("laDictionaryUnknownErr")
        self.assert_not_wrapped("laDictionaryTooManyErr")
        self.assert_not_wrapped("laPropertyValueErr")
        self.assert_not_wrapped("laPropertyUnknownErr")
        self.assert_not_wrapped("laPropertyIsReadOnlyErr")
        self.assert_not_wrapped("laPropertyNotFoundErr")
        self.assert_not_wrapped("laPropertyErr")
        self.assert_not_wrapped("laEngineNotFoundErr")
        self.assert_not_wrapped("kUSBNoErr")
        self.assert_not_wrapped("kUSBNoTran")
        self.assert_not_wrapped("kUSBNoDelay")
        self.assert_not_wrapped("kUSBPending")
        self.assert_not_wrapped("kUSBNotSent2Err")
        self.assert_not_wrapped("kUSBNotSent1Err")
        self.assert_not_wrapped("kUSBBufUnderRunErr")
        self.assert_not_wrapped("kUSBBufOvrRunErr")
        self.assert_not_wrapped("kUSBRes2Err")
        self.assert_not_wrapped("kUSBRes1Err")
        self.assert_not_wrapped("kUSBUnderRunErr")
        self.assert_not_wrapped("kUSBOverRunErr")
        self.assert_not_wrapped("kUSBWrongPIDErr")
        self.assert_not_wrapped("kUSBPIDCheckErr")
        self.assert_not_wrapped("kUSBNotRespondingErr")
        self.assert_not_wrapped("kUSBEndpointStallErr")
        self.assert_not_wrapped("kUSBDataToggleErr")
        self.assert_not_wrapped("kUSBBitstufErr")
        self.assert_not_wrapped("kUSBCRCErr")
        self.assert_not_wrapped("kUSBLinkErr")
        self.assert_not_wrapped("kUSBQueueFull")
        self.assert_not_wrapped("kUSBNotHandled")
        self.assert_not_wrapped("kUSBUnknownNotification")
        self.assert_not_wrapped("kUSBBadDispatchTable")
        self.assert_not_wrapped("kUSBInternalReserved10")
        self.assert_not_wrapped("kUSBInternalReserved9")
        self.assert_not_wrapped("kUSBInternalReserved8")
        self.assert_not_wrapped("kUSBInternalReserved7")
        self.assert_not_wrapped("kUSBInternalReserved6")
        self.assert_not_wrapped("kUSBInternalReserved5")
        self.assert_not_wrapped("kUSBInternalReserved4")
        self.assert_not_wrapped("kUSBInternalReserved3")
        self.assert_not_wrapped("kUSBInternalReserved2")
        self.assert_not_wrapped("kUSBInternalReserved1")
        self.assert_not_wrapped("kUSBPortDisabled")
        self.assert_not_wrapped("kUSBQueueAborted")
        self.assert_not_wrapped("kUSBTimedOut")
        self.assert_not_wrapped("kUSBDeviceDisconnected")
        self.assert_not_wrapped("kUSBDeviceNotSuspended")
        self.assert_not_wrapped("kUSBDeviceSuspended")
        self.assert_not_wrapped("kUSBInvalidBuffer")
        self.assert_not_wrapped("kUSBDevicePowerProblem")
        self.assert_not_wrapped("kUSBDeviceBusy")
        self.assert_not_wrapped("kUSBUnknownInterfaceErr")
        self.assert_not_wrapped("kUSBPipeStalledError")
        self.assert_not_wrapped("kUSBPipeIdleError")
        self.assert_not_wrapped("kUSBNoBandwidthError")
        self.assert_not_wrapped("kUSBAbortedError")
        self.assert_not_wrapped("kUSBFlagsError")
        self.assert_not_wrapped("kUSBCompletionError")
        self.assert_not_wrapped("kUSBPBLengthError")
        self.assert_not_wrapped("kUSBPBVersionError")
        self.assert_not_wrapped("kUSBNotFound")
        self.assert_not_wrapped("kUSBOutOfMemoryErr")
        self.assert_not_wrapped("kUSBDeviceErr")
        self.assert_not_wrapped("kUSBNoDeviceErr")
        self.assert_not_wrapped("kUSBAlreadyOpenErr")
        self.assert_not_wrapped("kUSBTooManyTransactionsErr")
        self.assert_not_wrapped("kUSBUnknownRequestErr")
        self.assert_not_wrapped("kUSBRqErr")
        self.assert_not_wrapped("kUSBIncorrectTypeErr")
        self.assert_not_wrapped("kUSBTooManyPipesErr")
        self.assert_not_wrapped("kUSBUnknownPipeErr")
        self.assert_not_wrapped("kUSBUnknownDeviceErr")
        self.assert_not_wrapped("kUSBInternalErr")
        self.assert_not_wrapped("dcmParamErr")
        self.assert_not_wrapped("dcmNotDictionaryErr")
        self.assert_not_wrapped("dcmBadDictionaryErr")
        self.assert_not_wrapped("dcmPermissionErr")
        self.assert_not_wrapped("dcmDictionaryNotOpenErr")
        self.assert_not_wrapped("dcmDictionaryBusyErr")
        self.assert_not_wrapped("dcmBlockFullErr")
        self.assert_not_wrapped("dcmNoRecordErr")
        self.assert_not_wrapped("dcmDupRecordErr")
        self.assert_not_wrapped("dcmNecessaryFieldErr")
        self.assert_not_wrapped("dcmBadFieldInfoErr")
        self.assert_not_wrapped("dcmBadFieldTypeErr")
        self.assert_not_wrapped("dcmNoFieldErr")
        self.assert_not_wrapped("dcmBadKeyErr")
        self.assert_not_wrapped("dcmTooManyKeyErr")
        self.assert_not_wrapped("dcmBadDataSizeErr")
        self.assert_not_wrapped("dcmBadFindMethodErr")
        self.assert_not_wrapped("dcmBadPropertyErr")
        self.assert_not_wrapped("dcmProtectedErr")
        self.assert_not_wrapped("dcmNoAccessMethodErr")
        self.assert_not_wrapped("dcmBadFeatureErr")
        self.assert_not_wrapped("dcmIterationCompleteErr")
        self.assert_not_wrapped("dcmBufferOverflowErr")
        self.assert_not_wrapped("kRAInvalidParameter")
        self.assert_not_wrapped("kRAInvalidPort")
        self.assert_not_wrapped("kRAStartupFailed")
        self.assert_not_wrapped("kRAPortSetupFailed")
        self.assert_not_wrapped("kRAOutOfMemory")
        self.assert_not_wrapped("kRANotSupported")
        self.assert_not_wrapped("kRAMissingResources")
        self.assert_not_wrapped("kRAIncompatiblePrefs")
        self.assert_not_wrapped("kRANotConnected")
        self.assert_not_wrapped("kRAConnectionCanceled")
        self.assert_not_wrapped("kRAUnknownUser")
        self.assert_not_wrapped("kRAInvalidPassword")
        self.assert_not_wrapped("kRAInternalError")
        self.assert_not_wrapped("kRAInstallationDamaged")
        self.assert_not_wrapped("kRAPortBusy")
        self.assert_not_wrapped("kRAUnknownPortState")
        self.assert_not_wrapped("kRAInvalidPortState")
        self.assert_not_wrapped("kRAInvalidSerialProtocol")
        self.assert_not_wrapped("kRAUserLoginDisabled")
        self.assert_not_wrapped("kRAUserPwdChangeRequired")
        self.assert_not_wrapped("kRAUserPwdEntryRequired")
        self.assert_not_wrapped("kRAUserInteractionRequired")
        self.assert_not_wrapped("kRAInitOpenTransportFailed")
        self.assert_not_wrapped("kRARemoteAccessNotReady")
        self.assert_not_wrapped("kRATCPIPInactive")
        self.assert_not_wrapped("kRATCPIPNotConfigured")
        self.assert_not_wrapped("kRANotPrimaryInterface")
        self.assert_not_wrapped("kRAConfigurationDBInitErr")
        self.assert_not_wrapped("kRAPPPProtocolRejected")
        self.assert_not_wrapped("kRAPPPAuthenticationFailed")
        self.assert_not_wrapped("kRAPPPNegotiationFailed")
        self.assert_not_wrapped("kRAPPPUserDisconnected")
        self.assert_not_wrapped("kRAPPPPeerDisconnected")
        self.assert_not_wrapped("kRAPeerNotResponding")
        self.assert_not_wrapped("kRAATalkInactive")
        self.assert_not_wrapped("kRAExtAuthenticationFailed")
        self.assert_not_wrapped("kRANCPRejectedbyPeer")
        self.assert_not_wrapped("kRADuplicateIPAddr")
        self.assert_not_wrapped("kRACallBackFailed")
        self.assert_not_wrapped("kRANotEnabled")
        self.assert_not_wrapped("kATSUInvalidTextLayoutErr")
        self.assert_not_wrapped("kATSUInvalidStyleErr")
        self.assert_not_wrapped("kATSUInvalidTextRangeErr")
        self.assert_not_wrapped("kATSUFontsMatched")
        self.assert_not_wrapped("kATSUFontsNotMatched")
        self.assert_not_wrapped("kATSUNoCorrespondingFontErr")
        self.assert_not_wrapped("kATSUInvalidFontErr")
        self.assert_not_wrapped("kATSUInvalidAttributeValueErr")
        self.assert_not_wrapped("kATSUInvalidAttributeSizeErr")
        self.assert_not_wrapped("kATSUInvalidAttributeTagErr")
        self.assert_not_wrapped("kATSUInvalidCacheErr")
        self.assert_not_wrapped("kATSUNotSetErr")
        self.assert_not_wrapped("kATSUNoStyleRunsAssignedErr")
        self.assert_not_wrapped("kATSUQuickDrawTextErr")
        self.assert_not_wrapped("kATSULowLevelErr")
        self.assert_not_wrapped("kATSUNoFontCmapAvailableErr")
        self.assert_not_wrapped("kATSUNoFontScalerAvailableErr")
        self.assert_not_wrapped("kATSUCoordinateOverflowErr")
        self.assert_not_wrapped("kATSULineBreakInWord")
        self.assert_not_wrapped("kATSUBusyObjectErr")
        self.assert_not_wrapped("kTextUnsupportedEncodingErr")
        self.assert_not_wrapped("kTextMalformedInputErr")
        self.assert_not_wrapped("kTextUndefinedElementErr")
        self.assert_not_wrapped("kTECMissingTableErr")
        self.assert_not_wrapped("kTECTableChecksumErr")
        self.assert_not_wrapped("kTECTableFormatErr")
        self.assert_not_wrapped("kTECCorruptConverterErr")
        self.assert_not_wrapped("kTECNoConversionPathErr")
        self.assert_not_wrapped("kTECBufferBelowMinimumSizeErr")
        self.assert_not_wrapped("kTECArrayFullErr")
        self.assert_not_wrapped("kTECBadTextRunErr")
        self.assert_not_wrapped("kTECPartialCharErr")
        self.assert_not_wrapped("kTECUnmappableElementErr")
        self.assert_not_wrapped("kTECIncompleteElementErr")
        self.assert_not_wrapped("kTECDirectionErr")
        self.assert_not_wrapped("kTECGlobalsUnavailableErr")
        self.assert_not_wrapped("kTECItemUnavailableErr")
        self.assert_not_wrapped("kTECUsedFallbacksStatus")
        self.assert_not_wrapped("kTECNeedFlushStatus")
        self.assert_not_wrapped("kTECOutputBufferFullStatus")
        self.assert_not_wrapped("strChecksumErr")
        self.assert_not_wrapped("strNoTableErr")
        self.assert_not_wrapped("strVariantErr")
        self.assert_not_wrapped("strFallbacksErr")
        self.assert_not_wrapped("strPartConvertErr")
        self.assert_not_wrapped("strBufErr")
        self.assert_not_wrapped("strCharErr")
        self.assert_not_wrapped("strElementErr")
        self.assert_not_wrapped("strNotFoundErr")
        self.assert_not_wrapped("strTableFormatErr")
        self.assert_not_wrapped("strDirectionErr")
        self.assert_not_wrapped("strContextualErr")
        self.assert_not_wrapped("strTextEncodingDataErr")
        self.assert_not_wrapped("kUTCUnderflowErr")
        self.assert_not_wrapped("kUTCOverflowErr")
        self.assert_not_wrapped("kIllegalClockValueErr")
        self.assert_not_wrapped("kATSUInvalidFontFallbacksErr")
        self.assert_not_wrapped("kATSUUnsupportedStreamFormatErr")
        self.assert_not_wrapped("kATSUBadStreamErr")
        self.assert_not_wrapped("kATSUOutputBufferTooSmallErr")
        self.assert_not_wrapped("kATSUInvalidCallInsideCallbackErr")
        self.assert_not_wrapped("kATSUNoFontNameErr")
        self.assert_not_wrapped("kATSULastErr")
        self.assert_not_wrapped("codecErr")
        self.assert_not_wrapped("noCodecErr")
        self.assert_not_wrapped("codecUnimpErr")
        self.assert_not_wrapped("codecSizeErr")
        self.assert_not_wrapped("codecScreenBufErr")
        self.assert_not_wrapped("codecImageBufErr")
        self.assert_not_wrapped("codecSpoolErr")
        self.assert_not_wrapped("codecAbortErr")
        self.assert_not_wrapped("codecWouldOffscreenErr")
        self.assert_not_wrapped("codecBadDataErr")
        self.assert_not_wrapped("codecDataVersErr")
        self.assert_not_wrapped("codecExtensionNotFoundErr")
        self.assert_not_wrapped("scTypeNotFoundErr")
        self.assert_not_wrapped("codecConditionErr")
        self.assert_not_wrapped("codecOpenErr")
        self.assert_not_wrapped("codecCantWhenErr")
        self.assert_not_wrapped("codecCantQueueErr")
        self.assert_not_wrapped("codecNothingToBlitErr")
        self.assert_not_wrapped("codecNoMemoryPleaseWaitErr")
        self.assert_not_wrapped("codecDisabledErr")
        self.assert_not_wrapped("codecNeedToFlushChainErr")
        self.assert_not_wrapped("lockPortBitsBadSurfaceErr")
        self.assert_not_wrapped("lockPortBitsWindowMovedErr")
        self.assert_not_wrapped("lockPortBitsWindowResizedErr")
        self.assert_not_wrapped("lockPortBitsWindowClippedErr")
        self.assert_not_wrapped("lockPortBitsBadPortErr")
        self.assert_not_wrapped("lockPortBitsSurfaceLostErr")
        self.assert_not_wrapped("codecParameterDialogConfirm")
        self.assert_not_wrapped("codecNeedAccessKeyErr")
        self.assert_not_wrapped("codecOffscreenFailedErr")
        self.assert_not_wrapped("codecDroppedFrameErr")
        self.assert_not_wrapped("directXObjectAlreadyExists")
        self.assert_not_wrapped("lockPortBitsWrongGDeviceErr")
        self.assert_not_wrapped("codecOffscreenFailedPleaseRetryErr")
        self.assert_not_wrapped("badCodecCharacterizationErr")
        self.assert_not_wrapped("noThumbnailFoundErr")
        self.assert_not_wrapped("kBadAdapterErr")
        self.assert_not_wrapped("kBadAttributeErr")
        self.assert_not_wrapped("kBadBaseErr")
        self.assert_not_wrapped("kBadEDCErr")
        self.assert_not_wrapped("kBadIRQErr")
        self.assert_not_wrapped("kBadOffsetErr")
        self.assert_not_wrapped("kBadPageErr")
        self.assert_not_wrapped("kBadSizeErr")
        self.assert_not_wrapped("kBadSocketErr")
        self.assert_not_wrapped("kBadTypeErr")
        self.assert_not_wrapped("kBadVccErr")
        self.assert_not_wrapped("kBadVppErr")
        self.assert_not_wrapped("kBadWindowErr")
        self.assert_not_wrapped("kBadArgLengthErr")
        self.assert_not_wrapped("kBadArgsErr")
        self.assert_not_wrapped("kBadHandleErr")
        self.assert_not_wrapped("kBadCISErr")
        self.assert_not_wrapped("kBadSpeedErr")
        self.assert_not_wrapped("kReadFailureErr")
        self.assert_not_wrapped("kWriteFailureErr")
        self.assert_not_wrapped("kGeneralFailureErr")
        self.assert_not_wrapped("kNoCardErr")
        self.assert_not_wrapped("kUnsupportedFunctionErr")
        self.assert_not_wrapped("kUnsupportedModeErr")
        self.assert_not_wrapped("kBusyErr")
        self.assert_not_wrapped("kWriteProtectedErr")
        self.assert_not_wrapped("kConfigurationLockedErr")
        self.assert_not_wrapped("kInUseErr")
        self.assert_not_wrapped("kNoMoreItemsErr")
        self.assert_not_wrapped("kOutOfResourceErr")
        self.assert_not_wrapped("kNoCardSevicesSocketsErr")
        self.assert_not_wrapped("kInvalidRegEntryErr")
        self.assert_not_wrapped("kBadLinkErr")
        self.assert_not_wrapped("kBadDeviceErr")
        self.assert_not_wrapped("k16BitCardErr")
        self.assert_not_wrapped("kCardBusCardErr")
        self.assert_not_wrapped("kPassCallToChainErr")
        self.assert_not_wrapped("kCantConfigureCardErr")
        self.assert_not_wrapped("kPostCardEventErr")
        self.assert_not_wrapped("kInvalidDeviceNumber")
        self.assert_not_wrapped("kUnsupportedVsErr")
        self.assert_not_wrapped("kInvalidCSClientErr")
        self.assert_not_wrapped("kBadTupleDataErr")
        self.assert_not_wrapped("kBadCustomIFIDErr")
        self.assert_not_wrapped("kNoIOWindowRequestedErr")
        self.assert_not_wrapped("kNoMoreTimerClientsErr")
        self.assert_not_wrapped("kNoMoreInterruptSlotsErr")
        self.assert_not_wrapped("kNoClientTableErr")
        self.assert_not_wrapped("kUnsupportedCardErr")
        self.assert_not_wrapped("kNoCardEnablersFoundErr")
        self.assert_not_wrapped("kNoEnablerForCardErr")
        self.assert_not_wrapped("kNoCompatibleNameErr")
        self.assert_not_wrapped("kClientRequestDenied")
        self.assert_not_wrapped("kNotReadyErr")
        self.assert_not_wrapped("kTooManyIOWindowsErr")
        self.assert_not_wrapped("kAlreadySavedStateErr")
        self.assert_not_wrapped("kAttemptDupCardEntryErr")
        self.assert_not_wrapped("kCardPowerOffErr")
        self.assert_not_wrapped("kNotZVCapableErr")
        self.assert_not_wrapped("kNoCardBusCISErr")
        self.assert_not_wrapped("noDeviceForChannel")
        self.assert_not_wrapped("grabTimeComplete")
        self.assert_not_wrapped("cantDoThatInCurrentMode")
        self.assert_not_wrapped("notEnoughMemoryToGrab")
        self.assert_not_wrapped("notEnoughDiskSpaceToGrab")
        self.assert_not_wrapped("couldntGetRequiredComponent")
        self.assert_not_wrapped("badSGChannel")
        self.assert_not_wrapped("seqGrabInfoNotAvailable")
        self.assert_not_wrapped("deviceCantMeetRequest")
        self.assert_not_wrapped("badControllerHeight")
        self.assert_not_wrapped("editingNotAllowed")
        self.assert_not_wrapped("controllerBoundsNotExact")
        self.assert_not_wrapped("cannotSetWidthOfAttachedController")
        self.assert_not_wrapped("controllerHasFixedHeight")
        self.assert_not_wrapped("cannotMoveAttachedController")
        self.assert_not_wrapped("errAEBadKeyForm")
        self.assert_not_wrapped("errAECantHandleClass")
        self.assert_not_wrapped("errAECantSupplyType")
        self.assert_not_wrapped("errAECantUndo")
        self.assert_not_wrapped("errAEEventFailed")
        self.assert_not_wrapped("errAEIndexTooLarge")
        self.assert_not_wrapped("errAEInTransaction")
        self.assert_not_wrapped("errAELocalOnly")
        self.assert_not_wrapped("errAENoSuchTransaction")
        self.assert_not_wrapped("errAENotAnElement")
        self.assert_not_wrapped("errAENotASingleObject")
        self.assert_not_wrapped("errAENotModifiable")
        self.assert_not_wrapped("errAENoUserSelection")
        self.assert_not_wrapped("errAEPrivilegeError")
        self.assert_not_wrapped("errAEReadDenied")
        self.assert_not_wrapped("errAETypeError")
        self.assert_not_wrapped("errAEWriteDenied")
        self.assert_not_wrapped("errAENotAnEnumMember")
        self.assert_not_wrapped("errAECantPutThatThere")
        self.assert_not_wrapped("errAEPropertiesClash")
        self.assert_not_wrapped("telGenericError")
        self.assert_not_wrapped("telNoErr")
        self.assert_not_wrapped("telNoTools")
        self.assert_not_wrapped("telBadTermErr")
        self.assert_not_wrapped("telBadDNErr")
        self.assert_not_wrapped("telBadCAErr")
        self.assert_not_wrapped("telBadHandErr")
        self.assert_not_wrapped("telBadProcErr")
        self.assert_not_wrapped("telCAUnavail")
        self.assert_not_wrapped("telNoMemErr")
        self.assert_not_wrapped("telNoOpenErr")
        self.assert_not_wrapped("telBadHTypeErr")
        self.assert_not_wrapped("telHTypeNotSupp")
        self.assert_not_wrapped("telBadLevelErr")
        self.assert_not_wrapped("telBadVTypeErr")
        self.assert_not_wrapped("telVTypeNotSupp")
        self.assert_not_wrapped("telBadAPattErr")
        self.assert_not_wrapped("telAPattNotSupp")
        self.assert_not_wrapped("telBadIndex")
        self.assert_not_wrapped("telIndexNotSupp")
        self.assert_not_wrapped("telBadStateErr")
        self.assert_not_wrapped("telStateNotSupp")
        self.assert_not_wrapped("telBadIntExt")
        self.assert_not_wrapped("telIntExtNotSupp")
        self.assert_not_wrapped("telBadDNDType")
        self.assert_not_wrapped("telDNDTypeNotSupp")
        self.assert_not_wrapped("telFeatNotSub")
        self.assert_not_wrapped("telFeatNotAvail")
        self.assert_not_wrapped("telFeatActive")
        self.assert_not_wrapped("telFeatNotSupp")
        self.assert_not_wrapped("telConfLimitErr")
        self.assert_not_wrapped("telConfNoLimit")
        self.assert_not_wrapped("telConfErr")
        self.assert_not_wrapped("telConfRej")
        self.assert_not_wrapped("telTransferErr")
        self.assert_not_wrapped("telTransferRej")
        self.assert_not_wrapped("telCBErr")
        self.assert_not_wrapped("telConfLimitExceeded")
        self.assert_not_wrapped("telBadDNType")
        self.assert_not_wrapped("telBadPageID")
        self.assert_not_wrapped("telBadIntercomID")
        self.assert_not_wrapped("telBadFeatureID")
        self.assert_not_wrapped("telBadFwdType")
        self.assert_not_wrapped("telBadPickupGroupID")
        self.assert_not_wrapped("telBadParkID")
        self.assert_not_wrapped("telBadSelect")
        self.assert_not_wrapped("telBadBearerType")
        self.assert_not_wrapped("telBadRate")
        self.assert_not_wrapped("telDNTypeNotSupp")
        self.assert_not_wrapped("telFwdTypeNotSupp")
        self.assert_not_wrapped("telBadDisplayMode")
        self.assert_not_wrapped("telDisplayModeNotSupp")
        self.assert_not_wrapped("telNoCallbackRef")
        self.assert_not_wrapped("telAlreadyOpen")
        self.assert_not_wrapped("telStillNeeded")
        self.assert_not_wrapped("telTermNotOpen")
        self.assert_not_wrapped("telCANotAcceptable")
        self.assert_not_wrapped("telCANotRejectable")
        self.assert_not_wrapped("telCANotDeflectable")
        self.assert_not_wrapped("telPBErr")
        self.assert_not_wrapped("telBadFunction")
        self.assert_not_wrapped("telNoSuchTool")
        self.assert_not_wrapped("telUnknownErr")
        self.assert_not_wrapped("telNoCommFolder")
        self.assert_not_wrapped("telInitFailed")
        self.assert_not_wrapped("telBadCodeResource")
        self.assert_not_wrapped("telDeviceNotFound")
        self.assert_not_wrapped("telBadProcID")
        self.assert_not_wrapped("telValidateFailed")
        self.assert_not_wrapped("telAutoAnsNotOn")
        self.assert_not_wrapped("telDetAlreadyOn")
        self.assert_not_wrapped("telBadSWErr")
        self.assert_not_wrapped("telBadSampleRate")
        self.assert_not_wrapped("telNotEnoughdspBW")
        self.assert_not_wrapped("errTaskNotFound")
        self.assert_not_wrapped("pmBusyErr")
        self.assert_not_wrapped("pmReplyTOErr")
        self.assert_not_wrapped("pmSendStartErr")
        self.assert_not_wrapped("pmSendEndErr")
        self.assert_not_wrapped("pmRecvStartErr")
        self.assert_not_wrapped("pmRecvEndErr")
        self.assert_not_wrapped("kPowerHandlerExistsForDeviceErr")
        self.assert_not_wrapped("kPowerHandlerNotFoundForDeviceErr")
        self.assert_not_wrapped("kPowerHandlerNotFoundForProcErr")
        self.assert_not_wrapped("kPowerMgtMessageNotHandled")
        self.assert_not_wrapped("kPowerMgtRequestDenied")
        self.assert_not_wrapped("kCantReportProcessorTemperatureErr")
        self.assert_not_wrapped("kProcessorTempRoutineRequiresMPLib2")
        self.assert_not_wrapped("kNoSuchPowerSource")
        self.assert_not_wrapped("kBridgeSoftwareRunningCantSleep")
        self.assert_not_wrapped("debuggingExecutionContextErr")
        self.assert_not_wrapped("debuggingDuplicateSignatureErr")
        self.assert_not_wrapped("debuggingDuplicateOptionErr")
        self.assert_not_wrapped("debuggingInvalidSignatureErr")
        self.assert_not_wrapped("debuggingInvalidOptionErr")
        self.assert_not_wrapped("debuggingInvalidNameErr")
        self.assert_not_wrapped("debuggingNoCallbackErr")
        self.assert_not_wrapped("debuggingNoMatchErr")
        self.assert_not_wrapped("kHIDVersionIncompatibleErr")
        self.assert_not_wrapped("kHIDDeviceNotReady")
        self.assert_not_wrapped("kHIDSuccess")
        self.assert_not_wrapped("kHIDInvalidRangePageErr")
        self.assert_not_wrapped("kHIDReportIDZeroErr")
        self.assert_not_wrapped("kHIDReportCountZeroErr")
        self.assert_not_wrapped("kHIDReportSizeZeroErr")
        self.assert_not_wrapped("kHIDUnmatchedDesignatorRangeErr")
        self.assert_not_wrapped("kHIDUnmatchedStringRangeErr")
        self.assert_not_wrapped("kHIDInvertedUsageRangeErr")
        self.assert_not_wrapped("kHIDUnmatchedUsageRangeErr")
        self.assert_not_wrapped("kHIDInvertedPhysicalRangeErr")
        self.assert_not_wrapped("kHIDInvertedLogicalRangeErr")
        self.assert_not_wrapped("kHIDBadLogicalMaximumErr")
        self.assert_not_wrapped("kHIDBadLogicalMinimumErr")
        self.assert_not_wrapped("kHIDUsagePageZeroErr")
        self.assert_not_wrapped("kHIDEndOfDescriptorErr")
        self.assert_not_wrapped("kHIDNotEnoughMemoryErr")
        self.assert_not_wrapped("kHIDBadParameterErr")
        self.assert_not_wrapped("kHIDNullPointerErr")
        self.assert_not_wrapped("kHIDInvalidReportLengthErr")
        self.assert_not_wrapped("kHIDInvalidReportTypeErr")
        self.assert_not_wrapped("kHIDBadLogPhysValuesErr")
        self.assert_not_wrapped("kHIDIncompatibleReportErr")
        self.assert_not_wrapped("kHIDInvalidPreparsedDataErr")
        self.assert_not_wrapped("kHIDNotValueArrayErr")
        self.assert_not_wrapped("kHIDUsageNotFoundErr")
        self.assert_not_wrapped("kHIDValueOutOfRangeErr")
        self.assert_not_wrapped("kHIDBufferTooSmallErr")
        self.assert_not_wrapped("kHIDNullStateErr")
        self.assert_not_wrapped("kHIDBaseError")
        self.assert_not_wrapped("kModemOutOfMemory")
        self.assert_not_wrapped("kModemPreferencesMissing")
        self.assert_not_wrapped("kModemScriptMissing")
        self.assert_not_wrapped("kTXNEndIterationErr")
        self.assert_not_wrapped("kTXNCannotAddFrameErr")
        self.assert_not_wrapped("kTXNInvalidFrameIDErr")
        self.assert_not_wrapped("kTXNIllegalToCrossDataBoundariesErr")
        self.assert_not_wrapped("kTXNUserCanceledOperationErr")
        self.assert_not_wrapped("kTXNBadDefaultFileTypeWarning")
        self.assert_not_wrapped("kTXNCannotSetAutoIndentErr")
        self.assert_not_wrapped("kTXNRunIndexOutofBoundsErr")
        self.assert_not_wrapped("kTXNNoMatchErr")
        self.assert_not_wrapped("kTXNAttributeTagInvalidForRunErr")
        self.assert_not_wrapped("kTXNSomeOrAllTagsInvalidForRunErr")
        self.assert_not_wrapped("kTXNInvalidRunIndex")
        self.assert_not_wrapped("kTXNAlreadyInitializedErr")
        self.assert_not_wrapped("kTXNCannotTurnTSMOffWhenUsingUnicodeErr")
        self.assert_not_wrapped("kTXNCopyNotAllowedInEchoModeErr")
        self.assert_not_wrapped("kTXNDataTypeNotAllowedErr")
        self.assert_not_wrapped("kTXNATSUIIsNotInstalledErr")
        self.assert_not_wrapped("kTXNOutsideOfLineErr")
        self.assert_not_wrapped("kTXNOutsideOfFrameErr")
        self.assert_not_wrapped("printerStatusOpCodeNotSupportedErr")
        self.assert_not_wrapped("errKCNotAvailable")
        self.assert_not_wrapped("errKCReadOnly")
        self.assert_not_wrapped("errKCAuthFailed")
        self.assert_not_wrapped("errKCNoSuchKeychain")
        self.assert_not_wrapped("errKCInvalidKeychain")
        self.assert_not_wrapped("errKCDuplicateKeychain")
        self.assert_not_wrapped("errKCDuplicateCallback")
        self.assert_not_wrapped("errKCInvalidCallback")
        self.assert_not_wrapped("errKCDuplicateItem")
        self.assert_not_wrapped("errKCItemNotFound")
        self.assert_not_wrapped("errKCBufferTooSmall")
        self.assert_not_wrapped("errKCDataTooLarge")
        self.assert_not_wrapped("errKCNoSuchAttr")
        self.assert_not_wrapped("errKCInvalidItemRef")
        self.assert_not_wrapped("errKCInvalidSearchRef")
        self.assert_not_wrapped("errKCNoSuchClass")
        self.assert_not_wrapped("errKCNoDefaultKeychain")
        self.assert_not_wrapped("errKCInteractionNotAllowed")
        self.assert_not_wrapped("errKCReadOnlyAttr")
        self.assert_not_wrapped("errKCWrongKCVersion")
        self.assert_not_wrapped("errKCKeySizeNotAllowed")
        self.assert_not_wrapped("errKCNoStorageModule")
        self.assert_not_wrapped("errKCNoCertificateModule")
        self.assert_not_wrapped("errKCNoPolicyModule")
        self.assert_not_wrapped("errKCInteractionRequired")
        self.assert_not_wrapped("errKCDataNotAvailable")
        self.assert_not_wrapped("errKCDataNotModifiable")
        self.assert_not_wrapped("errKCCreateChainFailed")
        self.assert_not_wrapped("kUCOutputBufferTooSmall")
        self.assert_not_wrapped("kUCTextBreakLocatorMissingType")
        self.assert_not_wrapped("kUCTSNoKeysAddedToObjectErr")
        self.assert_not_wrapped("kUCTSSearchListErr")
        self.assert_not_wrapped("kUCTokenizerIterationFinished")
        self.assert_not_wrapped("kUCTokenizerUnknownLang")
        self.assert_not_wrapped("kUCTokenNotFound")
        self.assert_not_wrapped("kMPIterationEndErr")
        self.assert_not_wrapped("kMPPrivilegedErr")
        self.assert_not_wrapped("kMPProcessCreatedErr")
        self.assert_not_wrapped("kMPProcessTerminatedErr")
        self.assert_not_wrapped("kMPTaskCreatedErr")
        self.assert_not_wrapped("kMPTaskBlockedErr")
        self.assert_not_wrapped("kMPTaskStoppedErr")
        self.assert_not_wrapped("kMPBlueBlockingErr")
        self.assert_not_wrapped("kMPDeletedErr")
        self.assert_not_wrapped("kMPTimeoutErr")
        self.assert_not_wrapped("kMPTaskAbortedErr")
        self.assert_not_wrapped("kMPInsufficientResourcesErr")
        self.assert_not_wrapped("kMPInvalidIDErr")
        self.assert_not_wrapped("kMPNanokernelNeedsMemoryErr")
        self.assert_not_wrapped("kCollateAttributesNotFoundErr")
        self.assert_not_wrapped("kCollateInvalidOptions")
        self.assert_not_wrapped("kCollateMissingUnicodeTableErr")
        self.assert_not_wrapped("kCollateUnicodeConvertFailedErr")
        self.assert_not_wrapped("kCollatePatternNotFoundErr")
        self.assert_not_wrapped("kCollateInvalidChar")
        self.assert_not_wrapped("kCollateBufferTooSmall")
        self.assert_not_wrapped("kCollateInvalidCollationRef")
        self.assert_not_wrapped("kFNSInvalidReferenceErr")
        self.assert_not_wrapped("kFNSBadReferenceVersionErr")
        self.assert_not_wrapped("kFNSInvalidProfileErr")
        self.assert_not_wrapped("kFNSBadProfileVersionErr")
        self.assert_not_wrapped("kFNSDuplicateReferenceErr")
        self.assert_not_wrapped("kFNSMismatchErr")
        self.assert_not_wrapped("kFNSInsufficientDataErr")
        self.assert_not_wrapped("kFNSBadFlattenedSizeErr")
        self.assert_not_wrapped("kFNSNameNotFoundErr")
        self.assert_not_wrapped("kLocalesBufferTooSmallErr")
        self.assert_not_wrapped("kLocalesTableFormatErr")
        self.assert_not_wrapped("kLocalesDefaultDisplayStatus")
        self.assert_not_wrapped("kALMInternalErr")
        self.assert_not_wrapped("kALMGroupNotFoundErr")
        self.assert_not_wrapped("kALMNoSuchModuleErr")
        self.assert_not_wrapped("kALMModuleCommunicationErr")
        self.assert_not_wrapped("kALMDuplicateModuleErr")
        self.assert_not_wrapped("kALMInstallationErr")
        self.assert_not_wrapped("kALMDeferSwitchErr")
        self.assert_not_wrapped("kALMRebootFlagsLevelErr")
        self.assert_not_wrapped("kALMLocationNotFoundErr")
        self.assert_not_wrapped("kSSpInternalErr")
        self.assert_not_wrapped("kSSpVersionErr")
        self.assert_not_wrapped("kSSpCantInstallErr")
        self.assert_not_wrapped("kSSpParallelUpVectorErr")
        self.assert_not_wrapped("kSSpScaleToZeroErr")
        self.assert_not_wrapped("kNSpInitializationFailedErr")
        self.assert_not_wrapped("kNSpAlreadyInitializedErr")
        self.assert_not_wrapped("kNSpTopologyNotSupportedErr")
        self.assert_not_wrapped("kNSpPipeFullErr")
        self.assert_not_wrapped("kNSpHostFailedErr")
        self.assert_not_wrapped("kNSpProtocolNotAvailableErr")
        self.assert_not_wrapped("kNSpInvalidGameRefErr")
        self.assert_not_wrapped("kNSpInvalidParameterErr")
        self.assert_not_wrapped("kNSpOTNotPresentErr")
        self.assert_not_wrapped("kNSpOTVersionTooOldErr")
        self.assert_not_wrapped("kNSpMemAllocationErr")
        self.assert_not_wrapped("kNSpAlreadyAdvertisingErr")
        self.assert_not_wrapped("kNSpNotAdvertisingErr")
        self.assert_not_wrapped("kNSpInvalidAddressErr")
        self.assert_not_wrapped("kNSpFreeQExhaustedErr")
        self.assert_not_wrapped("kNSpRemovePlayerFailedErr")
        self.assert_not_wrapped("kNSpAddressInUseErr")
        self.assert_not_wrapped("kNSpFeatureNotImplementedErr")
        self.assert_not_wrapped("kNSpNameRequiredErr")
        self.assert_not_wrapped("kNSpInvalidPlayerIDErr")
        self.assert_not_wrapped("kNSpInvalidGroupIDErr")
        self.assert_not_wrapped("kNSpNoPlayersErr")
        self.assert_not_wrapped("kNSpNoGroupsErr")
        self.assert_not_wrapped("kNSpNoHostVolunteersErr")
        self.assert_not_wrapped("kNSpCreateGroupFailedErr")
        self.assert_not_wrapped("kNSpAddPlayerFailedErr")
        self.assert_not_wrapped("kNSpInvalidDefinitionErr")
        self.assert_not_wrapped("kNSpInvalidProtocolRefErr")
        self.assert_not_wrapped("kNSpInvalidProtocolListErr")
        self.assert_not_wrapped("kNSpTimeoutErr")
        self.assert_not_wrapped("kNSpGameTerminatedErr")
        self.assert_not_wrapped("kNSpConnectFailedErr")
        self.assert_not_wrapped("kNSpSendFailedErr")
        self.assert_not_wrapped("kNSpMessageTooBigErr")
        self.assert_not_wrapped("kNSpCantBlockErr")
        self.assert_not_wrapped("kNSpJoinFailedErr")
        self.assert_not_wrapped("kISpInternalErr")
        self.assert_not_wrapped("kISpSystemListErr")
        self.assert_not_wrapped("kISpBufferToSmallErr")
        self.assert_not_wrapped("kISpElementInListErr")
        self.assert_not_wrapped("kISpElementNotInListErr")
        self.assert_not_wrapped("kISpSystemInactiveErr")
        self.assert_not_wrapped("kISpDeviceInactiveErr")
        self.assert_not_wrapped("kISpSystemActiveErr")
        self.assert_not_wrapped("kISpDeviceActiveErr")
        self.assert_not_wrapped("kISpListBusyErr")
        self.assert_not_wrapped("kDSpNotInitializedErr")
        self.assert_not_wrapped("kDSpSystemSWTooOldErr")
        self.assert_not_wrapped("kDSpInvalidContextErr")
        self.assert_not_wrapped("kDSpInvalidAttributesErr")
        self.assert_not_wrapped("kDSpContextAlreadyReservedErr")
        self.assert_not_wrapped("kDSpContextNotReservedErr")
        self.assert_not_wrapped("kDSpContextNotFoundErr")
        self.assert_not_wrapped("kDSpFrameRateNotReadyErr")
        self.assert_not_wrapped("kDSpConfirmSwitchWarning")
        self.assert_not_wrapped("kDSpInternalErr")
        self.assert_not_wrapped("kDSpStereoContextErr")
        self.assert_not_wrapped("kFBCvTwinExceptionErr")
        self.assert_not_wrapped("kFBCnoIndexesFound")
        self.assert_not_wrapped("kFBCallocFailed")
        self.assert_not_wrapped("kFBCbadParam")
        self.assert_not_wrapped("kFBCfileNotIndexed")
        self.assert_not_wrapped("kFBCbadIndexFile")
        self.assert_not_wrapped("kFBCcompactionFailed")
        self.assert_not_wrapped("kFBCvalidationFailed")
        self.assert_not_wrapped("kFBCindexingFailed")
        self.assert_not_wrapped("kFBCcommitFailed")
        self.assert_not_wrapped("kFBCdeletionFailed")
        self.assert_not_wrapped("kFBCmoveFailed")
        self.assert_not_wrapped("kFBCtokenizationFailed")
        self.assert_not_wrapped("kFBCmergingFailed")
        self.assert_not_wrapped("kFBCindexCreationFailed")
        self.assert_not_wrapped("kFBCaccessorStoreFailed")
        self.assert_not_wrapped("kFBCaddDocFailed")
        self.assert_not_wrapped("kFBCflushFailed")
        self.assert_not_wrapped("kFBCindexNotFound")
        self.assert_not_wrapped("kFBCnoSearchSession")
        self.assert_not_wrapped("kFBCindexingCanceled")
        self.assert_not_wrapped("kFBCaccessCanceled")
        self.assert_not_wrapped("kFBCindexFileDestroyed")
        self.assert_not_wrapped("kFBCindexNotAvailable")
        self.assert_not_wrapped("kFBCsearchFailed")
        self.assert_not_wrapped("kFBCsomeFilesNotIndexed")
        self.assert_not_wrapped("kFBCillegalSessionChange")
        self.assert_not_wrapped("kFBCanalysisNotAvailable")
        self.assert_not_wrapped("kFBCbadIndexFileVersion")
        self.assert_not_wrapped("kFBCsummarizationCanceled")
        self.assert_not_wrapped("kFBCindexDiskIOFailed")
        self.assert_not_wrapped("kFBCbadSearchSession")
        self.assert_not_wrapped("kFBCnoSuchHit")
        self.assert_not_wrapped("notAQTVRMovieErr")
        self.assert_not_wrapped("constraintReachedErr")
        self.assert_not_wrapped("callNotSupportedByNodeErr")
        self.assert_not_wrapped("selectorNotSupportedByNodeErr")
        self.assert_not_wrapped("invalidNodeIDErr")
        self.assert_not_wrapped("invalidViewStateErr")
        self.assert_not_wrapped("timeNotInViewErr")
        self.assert_not_wrapped("propertyNotSupportedByNodeErr")
        self.assert_not_wrapped("settingNotSupportedByNodeErr")
        self.assert_not_wrapped("limitReachedErr")
        self.assert_not_wrapped("invalidNodeFormatErr")
        self.assert_not_wrapped("invalidHotSpotIDErr")
        self.assert_not_wrapped("noMemoryNodeFailedInitialize")
        self.assert_not_wrapped("streamingNodeNotReadyErr")
        self.assert_not_wrapped("qtvrLibraryLoadErr")
        self.assert_not_wrapped("qtvrUninitialized")
        self.assert_not_wrapped("themeInvalidBrushErr")
        self.assert_not_wrapped("themeProcessRegisteredErr")
        self.assert_not_wrapped("themeProcessNotRegisteredErr")
        self.assert_not_wrapped("themeBadTextColorErr")
        self.assert_not_wrapped("themeHasNoAccentsErr")
        self.assert_not_wrapped("themeBadCursorIndexErr")
        self.assert_not_wrapped("themeScriptFontNotFoundErr")
        self.assert_not_wrapped("themeMonitorDepthNotSupportedErr")
        self.assert_not_wrapped("themeNoAppropriateBrushErr")
        self.assert_not_wrapped("errMessageNotSupported")
        self.assert_not_wrapped("errDataNotSupported")
        self.assert_not_wrapped("errControlDoesntSupportFocus")
        self.assert_not_wrapped("errUnknownControl")
        self.assert_not_wrapped("errCouldntSetFocus")
        self.assert_not_wrapped("errNoRootControl")
        self.assert_not_wrapped("errRootAlreadyExists")
        self.assert_not_wrapped("errInvalidPartCode")
        self.assert_not_wrapped("errControlsAlreadyExist")
        self.assert_not_wrapped("errControlIsNotEmbedder")
        self.assert_not_wrapped("errDataSizeMismatch")
        self.assert_not_wrapped("errControlHiddenOrDisabled")
        self.assert_not_wrapped("errCantEmbedIntoSelf")
        self.assert_not_wrapped("errCantEmbedRoot")
        self.assert_not_wrapped("errItemNotControl")
        self.assert_not_wrapped("controlInvalidDataVersionErr")
        self.assert_not_wrapped("controlPropertyInvalid")
        self.assert_not_wrapped("controlPropertyNotFoundErr")
        self.assert_not_wrapped("controlHandleInvalidErr")
        self.assert_not_wrapped("kURLInvalidURLReferenceError")
        self.assert_not_wrapped("kURLProgressAlreadyDisplayedError")
        self.assert_not_wrapped("kURLDestinationExistsError")
        self.assert_not_wrapped("kURLInvalidURLError")
        self.assert_not_wrapped("kURLUnsupportedSchemeError")
        self.assert_not_wrapped("kURLServerBusyError")
        self.assert_not_wrapped("kURLAuthenticationError")
        self.assert_not_wrapped("kURLPropertyNotYetKnownError")
        self.assert_not_wrapped("kURLUnknownPropertyError")
        self.assert_not_wrapped("kURLPropertyBufferTooSmallError")
        self.assert_not_wrapped("kURLUnsettablePropertyError")
        self.assert_not_wrapped("kURLInvalidCallError")
        self.assert_not_wrapped("kURLFileEmptyError")
        self.assert_not_wrapped("kURLExtensionFailureError")
        self.assert_not_wrapped("kURLInvalidConfigurationError")
        self.assert_not_wrapped("kURLAccessNotAvailableError")
        self.assert_not_wrapped("kURL68kNotSupportedError")
        self.assert_not_wrapped("errCppGeneral")
        self.assert_not_wrapped("errCppbad_alloc")
        self.assert_not_wrapped("errCppbad_cast")
        self.assert_not_wrapped("errCppbad_exception")
        self.assert_not_wrapped("errCppbad_typeid")
        self.assert_not_wrapped("errCpplogic_error")
        self.assert_not_wrapped("errCppdomain_error")
        self.assert_not_wrapped("errCppinvalid_argument")
        self.assert_not_wrapped("errCpplength_error")
        self.assert_not_wrapped("errCppout_of_range")
        self.assert_not_wrapped("errCppruntime_error")
        self.assert_not_wrapped("errCppoverflow_error")
        self.assert_not_wrapped("errCpprange_error")
        self.assert_not_wrapped("errCppunderflow_error")
        self.assert_not_wrapped("errCppios_base_failure")
        self.assert_not_wrapped("errCppLastSystemDefinedError")
        self.assert_not_wrapped("errCppLastUserDefinedError")
        self.assert_not_wrapped("badComponentInstance")
        self.assert_not_wrapped("badComponentSelector")
        self.assert_not_wrapped("dsBusError")
        self.assert_not_wrapped("dsAddressErr")
        self.assert_not_wrapped("dsIllInstErr")
        self.assert_not_wrapped("dsZeroDivErr")
        self.assert_not_wrapped("dsChkErr")
        self.assert_not_wrapped("dsOvflowErr")
        self.assert_not_wrapped("dsPrivErr")
        self.assert_not_wrapped("dsTraceErr")
        self.assert_not_wrapped("dsLineAErr")
        self.assert_not_wrapped("dsLineFErr")
        self.assert_not_wrapped("dsMiscErr")
        self.assert_not_wrapped("dsCoreErr")
        self.assert_not_wrapped("dsIrqErr")
        self.assert_not_wrapped("dsIOCoreErr")
        self.assert_not_wrapped("dsLoadErr")
        self.assert_not_wrapped("dsFPErr")
        self.assert_not_wrapped("dsNoPackErr")
        self.assert_not_wrapped("dsNoPk1")
        self.assert_not_wrapped("dsNoPk2")
        self.assert_not_wrapped("dsNoPk3")
        self.assert_not_wrapped("dsNoPk4")
        self.assert_not_wrapped("dsNoPk5")
        self.assert_not_wrapped("dsNoPk6")
        self.assert_not_wrapped("dsNoPk7")
        self.assert_not_wrapped("dsMemFullErr")
        self.assert_not_wrapped("dsBadLaunch")
        self.assert_not_wrapped("dsFSErr")
        self.assert_not_wrapped("dsStknHeap")
        self.assert_not_wrapped("negZcbFreeErr")
        self.assert_not_wrapped("dsFinderErr")
        self.assert_not_wrapped("dsBadSlotInt")
        self.assert_not_wrapped("dsBadSANEOpcode")
        self.assert_not_wrapped("dsBadPatchHeader")
        self.assert_not_wrapped("menuPrgErr")
        self.assert_not_wrapped("dsMBarNFnd")
        self.assert_not_wrapped("dsHMenuFindErr")
        self.assert_not_wrapped("dsWDEFNotFound")
        self.assert_not_wrapped("dsCDEFNotFound")
        self.assert_not_wrapped("dsMDEFNotFound")
        self.assert_not_wrapped("dsNoFPU")
        self.assert_not_wrapped("dsNoPatch")
        self.assert_not_wrapped("dsBadPatch")
        self.assert_not_wrapped("dsParityErr")
        self.assert_not_wrapped("dsOldSystem")
        self.assert_not_wrapped("ds32BitMode")
        self.assert_not_wrapped("dsNeedToWriteBootBlocks")
        self.assert_not_wrapped("dsNotEnoughRAMToBoot")
        self.assert_not_wrapped("dsBufPtrTooLow")
        self.assert_not_wrapped("dsVMDeferredFuncTableFull")
        self.assert_not_wrapped("dsVMBadBackingStore")
        self.assert_not_wrapped("dsCantHoldSystemHeap")
        self.assert_not_wrapped("dsSystemRequiresPowerPC")
        self.assert_not_wrapped("dsGibblyMovedToDisabledFolder")
        self.assert_not_wrapped("dsUnBootableSystem")
        self.assert_not_wrapped("dsMustUseFCBAccessors")
        self.assert_not_wrapped("dsMacOSROMVersionTooOld")
        self.assert_not_wrapped("dsLostConnectionToNetworkDisk")
        self.assert_not_wrapped("dsRAMDiskTooBig")
        self.assert_not_wrapped("dsWriteToSupervisorStackGuardPage")
        self.assert_not_wrapped("dsReinsert")
        self.assert_not_wrapped("shutDownAlert")
        self.assert_not_wrapped("dsShutDownOrRestart")
        self.assert_not_wrapped("dsSwitchOffOrRestart")
        self.assert_not_wrapped("dsForcedQuit")
        self.assert_not_wrapped("dsRemoveDisk")
        self.assert_not_wrapped("dsDirtyDisk")
        self.assert_not_wrapped("dsShutDownOrResume")
        self.assert_not_wrapped("dsSCSIWarn")
        self.assert_not_wrapped("dsMBSysError")
        self.assert_not_wrapped("dsMBFlpySysError")
        self.assert_not_wrapped("dsMBATASysError")
        self.assert_not_wrapped("dsMBATAPISysError")
        self.assert_not_wrapped("dsMBExternFlpySysError")
        self.assert_not_wrapped("dsPCCardATASysError")
        self.assert_not_wrapped("dsNoExtsMacsBug")
        self.assert_not_wrapped("dsNoExtsDisassembler")
        self.assert_not_wrapped("dsMacsBugInstalled")
        self.assert_not_wrapped("dsDisassemblerInstalled")
        self.assert_not_wrapped("dsExtensionsDisabled")
        self.assert_not_wrapped("dsGreeting")
        self.assert_not_wrapped("dsSysErr")
        self.assert_not_wrapped("WDEFNFnd")
        self.assert_not_wrapped("CDEFNFnd")
        self.assert_not_wrapped("dsNotThe1")
        self.assert_not_wrapped("dsBadStartupDisk")
        self.assert_not_wrapped("dsSystemFileErr")
        self.assert_not_wrapped("dsHD20Installed")
        self.assert_not_wrapped("mBarNFnd")
        self.assert_not_wrapped("fsDSIntErr")
        self.assert_not_wrapped("hMenuFindErr")
        self.assert_not_wrapped("userBreak")
        self.assert_not_wrapped("strUserBreak")
        self.assert_not_wrapped("exUserBreak")
        self.assert_not_wrapped("dsBadLibrary")
        self.assert_not_wrapped("dsMixedModeFailure")
        self.assert_not_wrapped("kPOSIXErrorBase")
        self.assert_not_wrapped("kPOSIXErrorEPERM")
        self.assert_not_wrapped("kPOSIXErrorENOENT")
        self.assert_not_wrapped("kPOSIXErrorESRCH")
        self.assert_not_wrapped("kPOSIXErrorEINTR")
        self.assert_not_wrapped("kPOSIXErrorEIO")
        self.assert_not_wrapped("kPOSIXErrorENXIO")
        self.assert_not_wrapped("kPOSIXErrorE2BIG")
        self.assert_not_wrapped("kPOSIXErrorENOEXEC")
        self.assert_not_wrapped("kPOSIXErrorEBADF")
        self.assert_not_wrapped("kPOSIXErrorECHILD")
        self.assert_not_wrapped("kPOSIXErrorEDEADLK")
        self.assert_not_wrapped("kPOSIXErrorENOMEM")
        self.assert_not_wrapped("kPOSIXErrorEACCES")
        self.assert_not_wrapped("kPOSIXErrorEFAULT")
        self.assert_not_wrapped("kPOSIXErrorENOTBLK")
        self.assert_not_wrapped("kPOSIXErrorEBUSY")
        self.assert_not_wrapped("kPOSIXErrorEEXIST")
        self.assert_not_wrapped("kPOSIXErrorEXDEV")
        self.assert_not_wrapped("kPOSIXErrorENODEV")
        self.assert_not_wrapped("kPOSIXErrorENOTDIR")
        self.assert_not_wrapped("kPOSIXErrorEISDIR")
        self.assert_not_wrapped("kPOSIXErrorEINVAL")
        self.assert_not_wrapped("kPOSIXErrorENFILE")
        self.assert_not_wrapped("kPOSIXErrorEMFILE")
        self.assert_not_wrapped("kPOSIXErrorENOTTY")
        self.assert_not_wrapped("kPOSIXErrorETXTBSY")
        self.assert_not_wrapped("kPOSIXErrorEFBIG")
        self.assert_not_wrapped("kPOSIXErrorENOSPC")
        self.assert_not_wrapped("kPOSIXErrorESPIPE")
        self.assert_not_wrapped("kPOSIXErrorEROFS")
        self.assert_not_wrapped("kPOSIXErrorEMLINK")
        self.assert_not_wrapped("kPOSIXErrorEPIPE")
        self.assert_not_wrapped("kPOSIXErrorEDOM")
        self.assert_not_wrapped("kPOSIXErrorERANGE")
        self.assert_not_wrapped("kPOSIXErrorEAGAIN")
        self.assert_not_wrapped("kPOSIXErrorEINPROGRESS")
        self.assert_not_wrapped("kPOSIXErrorEALREADY")
        self.assert_not_wrapped("kPOSIXErrorENOTSOCK")
        self.assert_not_wrapped("kPOSIXErrorEDESTADDRREQ")
        self.assert_not_wrapped("kPOSIXErrorEMSGSIZE")
        self.assert_not_wrapped("kPOSIXErrorEPROTOTYPE")
        self.assert_not_wrapped("kPOSIXErrorENOPROTOOPT")
        self.assert_not_wrapped("kPOSIXErrorEPROTONOSUPPORT")
        self.assert_not_wrapped("kPOSIXErrorESOCKTNOSUPPORT")
        self.assert_not_wrapped("kPOSIXErrorENOTSUP")
        self.assert_not_wrapped("kPOSIXErrorEPFNOSUPPORT")
        self.assert_not_wrapped("kPOSIXErrorEAFNOSUPPORT")
        self.assert_not_wrapped("kPOSIXErrorEADDRINUSE")
        self.assert_not_wrapped("kPOSIXErrorEADDRNOTAVAIL")
        self.assert_not_wrapped("kPOSIXErrorENETDOWN")
        self.assert_not_wrapped("kPOSIXErrorENETUNREACH")
        self.assert_not_wrapped("kPOSIXErrorENETRESET")
        self.assert_not_wrapped("kPOSIXErrorECONNABORTED")
        self.assert_not_wrapped("kPOSIXErrorECONNRESET")
        self.assert_not_wrapped("kPOSIXErrorENOBUFS")
        self.assert_not_wrapped("kPOSIXErrorEISCONN")
        self.assert_not_wrapped("kPOSIXErrorENOTCONN")
        self.assert_not_wrapped("kPOSIXErrorESHUTDOWN")
        self.assert_not_wrapped("kPOSIXErrorETOOMANYREFS")
        self.assert_not_wrapped("kPOSIXErrorETIMEDOUT")
        self.assert_not_wrapped("kPOSIXErrorECONNREFUSED")
        self.assert_not_wrapped("kPOSIXErrorELOOP")
        self.assert_not_wrapped("kPOSIXErrorENAMETOOLONG")
        self.assert_not_wrapped("kPOSIXErrorEHOSTDOWN")
        self.assert_not_wrapped("kPOSIXErrorEHOSTUNREACH")
        self.assert_not_wrapped("kPOSIXErrorENOTEMPTY")
        self.assert_not_wrapped("kPOSIXErrorEPROCLIM")
        self.assert_not_wrapped("kPOSIXErrorEUSERS")
        self.assert_not_wrapped("kPOSIXErrorEDQUOT")
        self.assert_not_wrapped("kPOSIXErrorESTALE")
        self.assert_not_wrapped("kPOSIXErrorEREMOTE")
        self.assert_not_wrapped("kPOSIXErrorEBADRPC")
        self.assert_not_wrapped("kPOSIXErrorERPCMISMATCH")
        self.assert_not_wrapped("kPOSIXErrorEPROGUNAVAIL")
        self.assert_not_wrapped("kPOSIXErrorEPROGMISMATCH")
        self.assert_not_wrapped("kPOSIXErrorEPROCUNAVAIL")
        self.assert_not_wrapped("kPOSIXErrorENOLCK")
        self.assert_not_wrapped("kPOSIXErrorENOSYS")
        self.assert_not_wrapped("kPOSIXErrorEFTYPE")
        self.assert_not_wrapped("kPOSIXErrorEAUTH")
        self.assert_not_wrapped("kPOSIXErrorENEEDAUTH")
        self.assert_not_wrapped("kPOSIXErrorEPWROFF")
        self.assert_not_wrapped("kPOSIXErrorEDEVERR")
        self.assert_not_wrapped("kPOSIXErrorEOVERFLOW")
        self.assert_not_wrapped("kPOSIXErrorEBADEXEC")
        self.assert_not_wrapped("kPOSIXErrorEBADARCH")
        self.assert_not_wrapped("kPOSIXErrorESHLIBVERS")
        self.assert_not_wrapped("kPOSIXErrorEBADMACHO")
        self.assert_not_wrapped("kPOSIXErrorECANCELED")
        self.assert_not_wrapped("kPOSIXErrorEIDRM")
        self.assert_not_wrapped("kPOSIXErrorENOMSG")
        self.assert_not_wrapped("kPOSIXErrorEILSEQ")
        self.assert_not_wrapped("kPOSIXErrorENOATTR")
        self.assert_not_wrapped("kPOSIXErrorEBADMSG")
        self.assert_not_wrapped("kPOSIXErrorEMULTIHOP")
        self.assert_not_wrapped("kPOSIXErrorENODATA")
        self.assert_not_wrapped("kPOSIXErrorENOLINK")
        self.assert_not_wrapped("kPOSIXErrorENOSR")
        self.assert_not_wrapped("kPOSIXErrorENOSTR")
        self.assert_not_wrapped("kPOSIXErrorEPROTO")
        self.assert_not_wrapped("kPOSIXErrorETIME")
        self.assert_not_wrapped("kPOSIXErrorEOPNOTSUPP")
        self.assert_not_wrapped("SysError")
